package hicharted.attribute;

import hicharted.dataStructure.TreeNode;
import hicharted.hcpgg.*;

import java.util.*;

/**
 * HichartXgWvZNX
 */
public class Coordinate {
	boolean end_flag = false;
	Stack c_stack = new Stack();
	int leafY = 10;
	int maxHeight = 0;

	/**
	 * W]
	 * @param TreeNode \
	 */
	public void coordinateCalc(TreeNode n) {
		pre(n);
		//System.out.println("");
		post(n);
	}

	/**
	 * s̒H
	 * @param n ؍\f[^
	 */
	private void pre(TreeNode n) {
		TreeNode tmp = new TreeNode();
		Productions ps = new Productions();
		Production pr = new Production();

		cordinate_stack_push(n);
		while (!checkEmpty()) {
			tmp = cordinate_stack_pop();

			pr = ps.getProduction(tmp.getProduction());
			if (pr != null) {
				pr.coordinateAttCalcI(tmp);
				if (maxHeight < tmp.getH1())
					maxHeight = tmp.getH1();
				//printInfo(tmp);
			}
			if (tmp.getChildren2() != null)
				cordinate_stack_push(tmp.getChildren2());
			if (tmp.getChildren1() != null)
				cordinate_stack_push(tmp.getChildren1());

			if (tmp.getChildren1() == null && tmp.getChildren2() == null) {
				tmp.setY1(leafY);
				//leafY = leafY + tmp.getH1() + tmp.getGapY();
				leafY = leafY + maxHeight + tmp.getGapY();
				maxHeight = 0;
			}
		}

	}
	/**
	 * s̒H
	 * @param n ؍\f[^
	 */
	private void post(TreeNode n) {
		TreeNode tmp = new TreeNode();
		Productions ps = new Productions();
		Production pr = new Production();

		cordinate_stack_push(n);
		while (!checkEmpty()) {
			tmp = cordinate_stack_pop();
			if (tmp.getVisit() == 0) {
				tmp.setVist(1);
				//printInfo(tmp);

				cordinate_stack_push(tmp);
				if (tmp.getChildren1() != null) {
					cordinate_stack_push(tmp.getChildren1());
				}

			} else if (tmp.getVisit() == 1) {
				tmp.setVist(2);
				//printInfo(tmp);

				cordinate_stack_push(tmp);

				if (tmp.getChildren2() != null) {
					cordinate_stack_push(tmp.getChildren2());
				}
			} else {
				pr = ps.getProduction(tmp.getProduction());
				if (pr != null) {
					pr.coordinateAttCalcS(tmp);
					//printInfo(tmp);
				}
			}
		}
	}

	/**
	 * f[^\
	 * @param n ؍\
	 */
	public void printInfo(TreeNode n) {
		System.out.println("K:" + n.getProduction() + "	x0W:" + n.getX0() + "	x1W:" + n.getX1() + "	x2W:" + n.getX2() + "	x3W:" + n.getX3() + "	y0W:" + n.getY0() + "	y1W:" + n.getY1() + "	y2W:" + n.getY2() + "	y3W:" + n.getY3() + "	top0W" + n.getTop0() + "	top1W" + n.getTop1() + "	top2W" + n.getTop2() + "	top3W:" + n.getTop3() + "	bottom0W" + n.getBottom0() + "	bottom1W" + n.getBottom1() + "	bottom2W" + n.getBottom2() + "	bottom3W:" + n.getBottom3() + " W1" + n.getW1() + " H1" + n.getH1());
	}

	/**
	 * WvẐ߂̃X^bNEvbV
	 * @param TreeNode
	 */
	private void cordinate_stack_push(TreeNode tn) {
		try {
			c_stack.push(tn);
		} catch (EmptyStackException e) {
		}
	}

	/**
	 * WvẐ߂̃X^bNE|bv
	 * @param Ȃ
	 */
	private TreeNode cordinate_stack_pop() {
		TreeNode tn = new TreeNode();
		int b = -1;
		try { //popŎľ^ObjectȂObjectɈꎞۑ
			if (c_stack.empty()) {
				return null;
			} else {
				Object tmp = c_stack.pop();
				/*
				 int^ɂ邽߂ɃbpNXIntegerɈꎞۑ
				  Integer a = ( Integer )tmp;
				//int^ɕϊ
				b = a.intValue( );
				*/
				tn = (TreeNode) tmp;
			}
		} catch (EmptyStackException e) {
		}
		//System.out.println("pop:" + tn.getProduction());
		return (tn);
	}

	private boolean checkEmpty() {
		if (c_stack.empty())
			return true;
		else
			return false;
	}
}