package hicharted.attribute;

import hicharted.dataStructure.*;
import hicharted.hcpgg.*;
import hicharted.*;

import java.io.*;
import java.util.*;
/**
 * SVGt@CNX
 * 
 *
 */
public class SVGout {
	StringBuffer ssvg = new StringBuffer();
	FileOutputStream out;
	PrintWriter w;

	/**
	 * SVGt@C쐬O
	 * @param nodeFileName t@C̃pX
	 */
	public void preProcessing(String nodeFileName) {
		try {
			ssvg = new StringBuffer();
			out = new FileOutputStream(nodeFileName); // o̓t@CJ
			w = new PrintWriter(out);

			//ssvg.append("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n");
			ssvg.append("<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n");
			ssvg.append("<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 20001102//EN\" \"http://www.w3.org/TR/2000/CR-SVG-20001102/DTD/svg-20001102.dtd\">");

			ssvg.append("<svg>\n");

		} catch (IOException ioe) {
			System.out.println(ioe.toString());
			System.exit(1);

		}
	}

	/**
	 * SVGt@C쐬㏈
	 * @param n 
	 */
	public void postProcessing() {
		int p = 0;
		TreeNode tmp = new TreeNode();
		try {
			ssvg.append("</svg>");
			w.println(ssvg);
			w.close();
			out.close();
			System.out.println("SVGt@C");
		} catch (IOException ioe) {
			System.out.println(ioe.toString());
			System.exit(1);

		}
	}

	/**
	 * SVGt@C쐬
	 * @param n o؃f[^
	 */
	public void svg(TreeNode n) {
		if (n.getChildren1() != null) //q
			svg(n.getChildren1());
		if (n.getChildren2() != null) //킪
			svg(n.getChildren2());

		Productions ps = new Productions();
		Production pr = new Production();
		pr = ps.getProduction(n.getProduction());

		if (pr != null) {
			pr.genSvg(n);
		}

		if (n.getProduction() == 1) {
			ssvg.append(n.getSSvg0());

			//DXL\̎́AGbW̏ʂɍsB
			if (State.getDispType() == 1) {
				addEdge();
			}
		}

		System.out.println("K " + n.getProduction() + "@yW " + n.getY1() + "@bottomW" + n.getBottom1());
	}

	/**
	 * GbW̒ǉ
	 *
	 */
	public void addEdge() {
		int from_num = 0;
		int to_num = 0;
		TempNode tempnode = new TempNode();
		TempNode tempnode2 = new TempNode();
		TempEdge tempedge = TempEdge.getRoot();

		while (tempedge != null) {
			boolean findflag1 = false;
			boolean findflag2 = false;
			from_num = tempedge.getFrom_node();
			to_num = tempedge.getTo_node();

			tempnode = TempNode.getRoot();
			while (tempnode != null) {
				if (tempnode.getNodeID() == from_num) {
					findflag1 = true;
					break;
				}
				if (tempnode.getNext() != null) {
					tempnode = tempnode.getNext();
				} else
					tempnode = null;
			}

			tempnode2 = TempNode.getRoot();
			while (tempnode2 != null) {
				if (tempnode2.getNodeID() == to_num) {
					findflag2 = true;
					break;
				}
				if (tempnode2.getNext() != null)
					tempnode2 = tempnode2.getNext();
				else
					tempnode2 = null;
			}

			if (findflag1 == true && findflag2 == true) {
				if (State.getDispType() == 1 && (tempnode.getNodeLabel().compareTo("if_then") == 0 || tempnode.getNodeLabel().compareTo("if_then") == 0 || tempnode.getNodeLabel().compareTo("else_if_then") == 0 || tempnode.getNodeLabel().compareTo("statement_head") == 0 || tempnode.getNodeLabel().compareTo("true") == 0 || tempnode.getNodeLabel().compareTo("false") == 0 || tempnode.getNodeLabel().compareTo("inclusive_case") == 0 || tempnode.getNodeLabel().compareTo("exclusive_case") == 0 || tempnode.getNodeLabel().compareTo("choice_specification") == 0)) {
					if (tempnode.getNodeLabel().compareTo("if_then") == 0 || tempnode.getNodeLabel().compareTo("else_if_then") == 0 || tempnode.getNodeLabel().compareTo("inclusive_case") == 0 || tempnode.getNodeLabel().compareTo("exclusive_case") == 0) {
						Vector children = tempnode.getChildren();
						if (children != null && children.size() > 0) {
							TempNode dummy;
							for (int i = 0; i < children.size(); i++) {
								dummy = (TempNode) children.get(i);
								if (children.size() == 1)
									ssvg.append("<line x1=\"" + (tempnode.getDrawPoint().x + tempnode.getNodeSize().x) + "\" y1=\"" + (tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2) + "\" x2=\"" + (dummy.getDrawPoint().x) + "\" y2=\"" + (dummy.getDrawPoint().y + tempnode.getNodeSize().y / 2) + "\" stroke=\"black\">" + "</line>\n");
								else {
									ssvg.append("<line x1=\"" + (tempnode.getDrawPoint().x + tempnode.getNodeSize().x + State.EDGE_X_GAP / 2) + "\" y1=\"" + (tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2) + "\" x2=\"" + (dummy.getDrawPoint().x - State.EDGE_X_GAP / 2) + "\" y2=\"" + (dummy.getDrawPoint().y + dummy.getNodeSize().y / 2) + "\" stroke=\"black\">" + "</line>\n");
									ssvg.append("<line x1=\"" + (dummy.getDrawPoint().x - State.EDGE_X_GAP / 2) + "\" y1=\"" + (dummy.getDrawPoint().y + dummy.getNodeSize().y / 2) + "\" x2=\"" + dummy.getDrawPoint().x + "\" y2=\"" + (dummy.getDrawPoint().y + dummy.getNodeSize().y / 2) + "\" stroke=\"black\">" + "</line>\n");
								}
							}
							ssvg.append("<line x1=\"" + (tempnode.getDrawPoint().x + tempnode.getNodeSize().x) + "\" y1=\"" + (tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2) + "\" x2=\"" + (tempnode.getDrawPoint().x + tempnode.getNodeSize().x + State.EDGE_X_GAP / 2) + "\" y2=\"" + (tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2) + "\" stroke=\"black\">" + "</line>\n");
						}
					} else if (tempnode.getNodeLabel().compareTo("statement_head") == 0) {
						if (tempnode2.getNodeLabel().compareTo("statement_head") == 0) {
							TempNode dummy1, dummy2;
							dummy1 = TempNode.searchTempNode(tempnode.getChildNum());
							dummy2 = TempNode.searchTempNode(tempnode2.getChildNum());
							ssvg.append("<line x1=\"" + (dummy1.getDrawPoint().x + State.EDGE_X_GAP) + "\" y1=\"" + (dummy1.getDrawPoint().y + dummy1.getNodeSize().y) + "\" x2=\"" + (dummy2.getDrawPoint().x + State.EDGE_X_GAP) + "\" y2=\"" + (dummy2.getDrawPoint().y) + "\" stroke=\"black\">" + "</line>\n");
						}
					}
				} else {
					switch (tempedge.getEdge_type()) {
						case 1 :
							ssvg.append("<line x1=\"" + (tempnode.getDrawPoint().x + tempnode.getNodeSize().x) + "\" y1=\"" + (tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2) + "\" x2=\"" + (tempnode2.getDrawPoint().x) + "\" y2=\"" + (tempnode2.getDrawPoint().y + tempnode.getNodeSize().y / 2) + "\" stroke=\"black\">" + "</line>\n");
							//g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2, tempnode2.getDrawPoint().x, (tempnode2.getDrawPoint().y + tempnode.getNodeSize().y / 2));
							break;
						case 2 :
							ssvg.append("<line x1=\"" + (tempnode.getDrawPoint().x + State.EDGE_X_GAP) + "\" y1=\"" + (tempnode.getDrawPoint().y + tempnode.getNodeSize().y) + "\" x2=\"" + (tempnode2.getDrawPoint().x + State.EDGE_X_GAP) + "\" y2=\"" + (tempnode2.getDrawPoint().y) + "\" stroke=\"black\">" + "</line>\n");
							//g.drawLine(tempnode.getDrawPoint().x + State.EDGE_X_GAP, tempnode.getDrawPoint().y + tempnode.getNodeSize().y, (tempnode2.getDrawPoint().x + State.EDGE_X_GAP), tempnode2.getDrawPoint().y);

					}
				}

			}

			if (tempedge.getNext() != null)
				tempedge = tempedge.getNext();
			else
				tempedge = null;

		}

	}

	public static Vector getStrings(String dispString) {
		Vector strings = new Vector();
		char ch;
		String tempString = new String();

		if (dispString != null) {

			for (int i = 0; i < dispString.length(); i++) {
				ch = dispString.charAt(i);
				if (ch == '\n') {
					strings.add(tempString);
					tempString = "";
				} else {
					if (ch == '<')
						tempString += "&lt;";
					else if (ch == '>')
						tempString += "&gt;";
					else
						tempString += ch;
					if (i == dispString.length() - 1)
						strings.add(tempString);
				}
			}
		}

		return strings;
	}
}
