package hicharted.dataStructure;

/**
 * nhpNX
 * 
 *
 */
public class Handle {
	private int number = 0; //m[hIDi[
	private String label = null; //m[h̃xiK15QƁji[
	private Handle back = null; //O̗vfւ̃N
	private Handle next = null; //̗vfւ̃N
	private HichartNode hclink = null; //HichartNodeւ̃N
	private static Handle root;
	private static Handle end;

	/**
	 * nhɃm[hǉ
	 * @param hn ǉΏۃm[h
	 */
	public void addNode(HichartNode hn) {
		Handle addNode = new Handle();
		addNode.next = new Handle();
		addNode.back = new Handle();
		addNode.hclink = hn;

		//N̐ݒ
		getEnd().back.next = addNode;
		addNode.back = Handle.end.back;
		addNode.next = Handle.end;
		addNode.next.back = addNode;

	}

	//Qb^[EZb^[
	public void setNumber(int number) {
		this.number = number;
	}

	public int getNumber() {
		return number;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public String getLabel() {
		return label;
	}

	public void setNext(Handle next) {
		this.next = next;
	}

	public Handle getNext() {
		return next;
	}

	public static void setRoot() {
		Handle.root = new Handle();
		Handle.end = new Handle();
		Handle.root.next = Handle.end;
		Handle.end.back = Handle.root;
	}

	public static Handle getRoot() {
		return root;
	}

	public static Handle getEnd() {
		return end;
	}
	
	private Handle getBack(){
		return this.back;
	}
	
	public HichartNode getHichartNode(){
		return this.hclink;
	}
	
	/**
	 * nho
	 *
	 */
	public void printHandle() {
		Handle node;
		node = getRoot().next;
		do {
			if (node.hclink.getNodeLabel() != null)
				System.out.println("nh: " + node.hclink.getNodeLabel());
			node = node.next;
		} while (node.next != null);

	}

}