package hicharted.dataStructure;

import java.util.*;

/**
 * parserŎgp鏇Xĝ߂̃NX
 */
public class OrderList {
	private static HichartNode tempNode;

	/**
	 * Xg̒ɁAœnꂽm[hi[Ă邩`FbN
	 * @param orderList Xg
	 * @param target m[h
	 * @return true m[hXgŌꍇ<br>
	 *          false m[hXgŌȂꍇ
	 */
	public static boolean search(Vector orderList, HichartNode target) {
		for (int i = 0; i < orderList.size(); i++) {
			tempNode = (HichartNode) orderList.get(i);
			if (tempNode.getNodeID() == target.getNodeID() && tempNode.getNodeLabel().compareTo(target.getNodeLabel()) == 0) {
				return true;
			}
		}
		return false;
	}

	/**
	 * œnꂽHichartNodevfԍ߂
	 * @param orderList Xg
	 * @param target ΏHichartNode
	 * @return zvfԍ
	 */
	public static int getSubscript(Vector orderList, HichartNode target) {
		for (int i = 0; i < orderList.size(); i++) {
			tempNode = (HichartNode) orderList.get(i);
			if (tempNode.getNodeID() == target.getNodeID() && tempNode.getNodeLabel().compareTo(target.getNodeLabel()) == 0) {
				return i;
			}
		}
		return -1;
	}

	/**
	 * OtɔAXg̏
	 * @param orderList Xg
	 * @param handle nh
	 * @return orderList Xg
	 */
	public static Vector remove(Vector orderList, HichartNode handle) {
		if (handle.getChild1() != null) {
			orderList = remove(orderList, handle.getChild1());
		}
		if (handle.getChild2() != null) {
			orderList = remove(orderList, handle.getChild2());
		}
		if (handle.getYoungerBrother() != null) {
			orderList = remove(orderList, handle.getYoungerBrother());
		}

		int subscript = OrderList.getSubscript(orderList, handle);
		if (subscript != -1)
			orderList.remove(subscript);

		return orderList;
	}
}
