package hicharted.dataStructure;

import java.io.*;
import java.awt.*;
import hicharted.*;

/**
 * 쐬ꂽGbWi[
 * 
 *
 */
public class TempEdge implements Serializable {
	private static final String ROOT = "root";
	private static final String END = "end";
	private static final String PtoC = "pc"; //eqԂ̃GbW
	private static final String OtoY = "oy"; //ZԂ̃GbW

	private int edge_type = 0; //1:pcGbW@eqԂ̃GbW 2:oy ZԂ̃GbW
	private int edgeID = 0;
	private int from_node = -1;
	private int to_node = -1;
	private String label;
	private Point edgeBeginPoint = null;
	private Point edgeEndPoint = null;
	private TempEdge next = null;
	private TempEdge back = null;

	private static TempEdge root;
	private static TempEdge end;
	//Ɨp
	private static TempEdge work;

	/**
	 * f[^
	 *
	 */
	public void format() {
		this.setRootEdge();
		this.setEndEdge();
		TempEdge.getRoot().setNext(end);
		end.setBack(root);
		//TempEdge.printTempNodeEdge();
	}

	/**
	 * f[^ǉ
	 *
	 */
	public static void insert() {
		TempNode temp;
		work = TempEdge.getEnd().getBack();
		work.setNext(new TempEdge());
		work.getNext().setBack(work);
		work = work.getNext();

		work.setEdgeID(State.getEdgeNum());
		work.setFrom_node(State.getBefore());
		work.setTo_node(State.getAfter());
		work.setNext(end);
		TempEdge.getEnd().setBack(work);

		//GbW̍Wݒ
		work.edgeBeginPoint = new Point();
		work.edgeEndPoint = new Point();
		TempNode beginNode = TempNode.searchTempNode(State.getBefore());
		TempNode endNode = TempNode.searchTempNode(State.getAfter());
		work.edgeBeginPoint.setLocation(beginNode.getDrawPoint().getX() + beginNode.getNodeSize().getX(), beginNode.getDrawPoint().getY() + beginNode.getNodeSize().getY() / 2);
		work.edgeEndPoint.setLocation(endNode.getDrawPoint().getX(), endNode.getDrawPoint().getY() + endNode.getNodeSize().getY() / 2);
		//System.out.println("edgebegin" + work.edgeBeginPoint);
		//System.out.println("edgebegin" + work.edgeEndPoint);

		//System.out.println("GbWԍݒ:" + State.get_edge_num());
		State.setEdgeNum(State.getEdgeNum() + 1);

		switch (State.getEdgeType()) {
			case 1 :
				TempEdge.getEnd().getBack().setEdge_type(State.getEdgeType());
				TempEdge.getEnd().getBack().setLabel(PtoC);
				//GbWۂɁAeq֌W`Xgɕۑ
				//temp = TempNode.searchTempNode(State.get_before());
				temp = TempNode.searchTempNode(State.getBefore());
				temp.setChild_num(State.getAfter());
				temp = TempNode.searchTempNode(State.getAfter());
				temp.setParentNum(State.getBefore());

				break;
			case 2 :
				TempEdge.getEnd().getBack().setEdge_type(State.getEdgeType());
				TempEdge.getEnd().getBack().setLabel(OtoY);
				//GbWЂۂɁAZ֌W`Xgɕۑ
				temp = TempNode.searchTempNode(State.getBefore());
				temp.setYoungerBrotherNum(State.getAfter());
				temp = TempNode.searchTempNode(State.getAfter());
				temp.setOldBrotherNum(State.getBefore());
				break;
		}
		//TempEdge.printTempNodeEdge();
	}

	/**
	 * f[^폜
	 * @param id1
	 * @param id2
	 */
	public static void delete(int id1, int id2) {
		work = TempEdge.getRoot();
		TempEdge test = work;

		while (work.getLabel().compareTo("end") != 0) {
			if ((work.from_node == id1 && work.to_node == id2) || (work.from_node == id2 && work.to_node == id1)) {
				work.getBack().setNext(work.getNext());
				work.getNext().setBack(work.getBack());
				//return;
			}
			work = work.getNext();
		}
	}

	public static void delete(TempEdge temp) {
		work = TempEdge.getRoot();
		TempEdge test = work;

		while (work.getLabel().compareTo("end") != 0) {
			if (work == temp) {
				work.getBack().setNext(work.getNext());
				work.getNext().setBack(work.getBack());
				return;
			}
			work = work.getNext();
		}
	}

	public static TempEdge searchEdge(int id) {
		work = TempEdge.getRoot();
		TempEdge test = work;

		while (work.getLabel().compareTo("end") != 0) {
			System.out.println("work .id" + work.getEdgeID() + " id: " + id);
			if (work.getEdgeID() == id) {
				return work;
			}
			work = work.getNext();
		}
		return null;
	}

	/**
	 * Iꂽ2̃m[hԂɃGbW݂Ă邩`FbN
	 */
	public static boolean searchEdge() {
		work = TempEdge.getRoot();
		while (true) {
			if (work.from_node == State.getBefore() && work.to_node == State.getAfter()) {
				return true;
			} else {
				if (work.getLabel().compareTo("end") != 0) {
					work = work.getNext();
				} else {
					break;
				}
			}
		}
		return false;
	}

	/**
	 * GbWPointŌ
	 */
	public static void searchEdge(Point clickPoint) {
		TempEdge work = TempEdge.getRoot().getNext();
		int leftUpperX, leftUpperY, rightLowerX, rightLowerY;
		if (work.edgeBeginPoint != null && work.edgeEndPoint != null) {

			//while (true) {
			while (work.getLabel().compareTo("end") != 0) {
				//̈vZs߂̍Wݒ
				if (work.edgeBeginPoint.x < work.edgeEndPoint.x) {
					leftUpperX = work.edgeBeginPoint.x;
					rightLowerX = work.edgeEndPoint.x - work.edgeBeginPoint.x;
				} else {
					leftUpperX = work.edgeEndPoint.x;
					rightLowerX = work.edgeBeginPoint.x - work.edgeEndPoint.x;
				}

				if (work.edgeBeginPoint.y < work.edgeEndPoint.y) {
					leftUpperY = work.edgeBeginPoint.y;
					if (work.edgeEndPoint.y - work.edgeBeginPoint.y < 10)
						rightLowerY = 10;
					else
						rightLowerY = work.edgeEndPoint.y - work.edgeBeginPoint.y;
				} else {
					leftUpperY = work.edgeEndPoint.y;
					if (work.edgeBeginPoint.y - work.edgeEndPoint.y < 10)
						rightLowerY = 10;
					else
						rightLowerY = work.edgeBeginPoint.y - work.edgeEndPoint.y;
				}

				Rectangle rect = new Rectangle(leftUpperX, leftUpperY, rightLowerX, rightLowerY);
				System.out.print("edgeID: " + work.getEdgeID() + " ");
				System.out.println(rect);
				System.out.println("NbN_:" + clickPoint);
				if (rect.contains(clickPoint.x, clickPoint.y)) {
					System.out.println("GbWqbg" + "ID " + work.getEdgeID());
					State.setEdgeHitID(work.edgeID);
					break;
				}
				work = work.getNext();
			}
		}
		work = null;
	}

	/**
	 * ̓GbWXgendZ
	 */
	public static TempEdge searchEndNode() {
		work = TempEdge.getRoot();
		while (true) {
			System.out.println("work.Label " + work.label);
			if (work.getLabel().compareTo("end") == 0) {
				TempEdge.setEndEdge(work);
				break;
			}
			if (work.getNext() != null)
				work = work.getNext();
			else
				break;
		}

		work = null;
		return work;
	}

	/**
	 * ͂̐`Xgꗗ\
	 */
	public static void printTempNodeEdge() {
		work = TempEdge.getRoot();
		System.out.println("==================================================================");
		while (work.getLabel().compareTo(END) != 0) {

			System.out.println("ID: " + work.getEdgeID());
			System.out.println("edge type: " + work.getEdge_type());
			System.out.println("edge label: " + work.getLabel());
			System.out.println("from_node: " + work.from_node);
			System.out.println("to_node: " + work.to_node);
			if (work.edgeBeginPoint != null) {
				System.out.println("from_point x: " + work.edgeBeginPoint.x);
				System.out.println("from_point y: " + work.edgeBeginPoint.y);
			}

			if (work.edgeEndPoint != null) {
				System.out.println("to_point: x" + work.edgeEndPoint.x);
				System.out.println("to_point: y" + work.edgeEndPoint.y + "\n");
			}

			work = work.getNext();
			//System.out.println("new work " + work.getEdgeID());
			//System.out.println("new worklabel " + work.getLabel() + "\n");
		}
		System.out.println("==================================================================");
	}

	/**
	 * GbW̍WXV
	 */
	public static void updatePoint() {
		work = TempEdge.getRoot().getNext();

		while (work.getLabel().compareTo(END) != 0) {
			TempNode fromNode = TempNode.searchTempNode(work.from_node);
			TempNode toNode = TempNode.searchTempNode(work.to_node);

			//GbW̎n_WXV
			work.edgeBeginPoint.x = fromNode.getDrawPoint().x + fromNode.getNodeSize().x;
			work.edgeBeginPoint.y = fromNode.getDrawPoint().y + fromNode.getNodeSize().y / 2;
			//GbW̏I_WXV
			work.edgeEndPoint.x = toNode.getDrawPoint().x;
			work.edgeEndPoint.y = toNode.getDrawPoint().y + toNode.getNodeSize().y / 2;

			work = work.getNext();
		}
	}

	//rootm[h̃Zbg
	private void setRootEdge() {
		//this.setNext(new TempEdge());
		root = new TempEdge();
		root.setEdge_type(0);
		root.setEdgeID(0);
		root.setLabel(ROOT);
	}
	public static void setRootNode(TempEdge input) {
		root = input;
	}

	//endm[h̃Zbg
	private void setEndEdge() {
		end = new TempEdge();
		end.setEdge_type(0);
		end.setEdgeID(0);
		end.setLabel(END);
	}

	public static void setEndEdge(TempEdge edge) {
		end = edge;
	}

	//eϐ̃Zb^[Qb^[
	public static TempEdge getRoot() {
		return root;
	}

	public static TempEdge getEnd() {
		return end;
	}

	public void setEdge_type(int edge_type) {
		this.edge_type = edge_type;
	}

	public int getEdge_type() {
		return edge_type;
	}

	public void setEdgeID(int iDnum) {
		edgeID = iDnum;
	}

	public int getEdgeID() {
		return edgeID;
	}

	public void setFrom_node(int from_node) {
		this.from_node = from_node;
	}

	public int getFrom_node() {
		return from_node;
	}

	public void setTo_node(int to_node) {
		this.to_node = to_node;
	}

	public int getTo_node() {
		return to_node;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public String getLabel() {
		return label;
	}

	public void setNext(TempEdge next) {
		this.next = next;
	}

	public TempEdge getNext() {
		return next;
	}

	public void setBack(TempEdge back) {
		this.back = back;
	}

	public TempEdge getBack() {
		return back;
	}

}