package hicharted.dataStructure;

import java.awt.*;
import java.lang.String;
import java.io.*;
import java.awt.font.*;
import java.awt.geom.*;
import java.util.*;

import hicharted.*;
import hicharted.event.*;
/**
 * ʃ_uNbNɁAm[hi[
 * 
 *
 */
public class TempNode implements Serializable {
	private int nodeID = 0; //m[hʔԍ
	private int NodeTypeNumber = -1; //m[hޔԍ
	private String string1 = ""; //Zɓ͂镶i[(i)
	private String string2 = ""; //Zɓ͂镶i[(i)
	private String ll = ""; //[U͗pZDi[
	private String cl = ""; //xi[
	private int parentNum = -1; //eIDi[
	private int childNum = -1; //qIDi[
	private int oldBrotherNum = -1; //ZIDi[
	private int youngerBrotherNum = -1; //IDi[
	private Point drawPoint = new Point(10, 10); //Z`W
	private Point nodeSize = new Point(60, 30); //ZTCY
	private String nodeLabel = ""; //p[Ypm[hxi[
	private String dispStr = ""; //Z\pi[
	private TempNode next = null; //`̓XgN
	private TempNode back = null; //`̓XgON
	private int leftMargin = 0;
	private int rightMargin = 0;
	int query = -1;
	private static TempNode work;
	private static TempNode root;
	private static TempNode end;
	private static Rectangle rectangle;

	static final int rowGap = 10;

	/**
	 * 
	 *
	 */
	public void format() {
		TempNode temp;
		this.setRootNode();
		temp = TempNode.getRoot();
		temp.setNodeLabel("root");
		temp.setNext(new TempNode());
		TempNode.setEndNode(temp.getNext());
		TempNode.getEnd().setBack(temp);
		TempNode.getEnd().setNodeLabel("end");
	}

	/**
	 * t@CI[vAm[h̒ǉ
	 */
	public static void insert() {
		work = TempNode.getEnd().getBack();
		work.setNext(new TempNode());
		work.getNext().setBack(work);
		work.getNext().setNext(TempNode.getEnd());
		TempNode.getEnd().setBack(work.getNext());
	}

	/**
	 * m[h̑}
	 * @param temp }m[h
	 */
	public static void insert(TempNode temp) {
		work = TempNode.getEnd().getBack();
		work.setNext(temp);
		work.getNext().setBack(work);
		work.getNext().setNext(TempNode.getEnd());
		TempNode.getEnd().setBack(work.getNext());
	}

	/**
	 * m[h̑}
	 */
	public static int insert(Point clickPoint) {
		work = TempNode.getEnd().getBack();
		work.setNext(new TempNode());
		work.getNext().setBack(work);
		work.getNext().setNext(TempNode.getEnd());
		TempNode.getEnd().setBack(work.getNext());
		TempNode.getEnd().getBack().getDrawPoint().x = clickPoint.x;
		TempNode.getEnd().getBack().getDrawPoint().y = clickPoint.y;
		TempNode.getEnd().getBack().setNodeTypeNumber(State.getNodeType());
		//_~[m[h͓ʂɐݒ
		if (State.getNodeType() == 10) {
			TempNode.getEnd().getBack().setNodeLabel("dummy");
			TempNode.getEnd().getBack().setNodeSize(new Point(State.dummySize, State.dummySize));
		}
		TempNode.getEnd().getBack().setNodeID(State.getNextNodeNum());
		TempNode.getEnd().getBack().setLeftMargin();
		TempNode.getEnd().getBack().setRightMargin();
		//System.out.println("_uNbN tempnode_end.back.NodeType" + TempNode.getEnd().getBack().getNodeTypeNumber());
		//System.out.println("̓m[hID tempnode_end.back.IDnum" + TempNode.getEnd().getBack().getNodeID());
		return TempNode.getEnd().getBack().getNodeID();
	}

	/**
	 * m[h̍폜
	 */
	public static void delete(TempNode delNode) {
		if (delNode.getNodeLabel().compareTo("root") == 0 || delNode.getNodeLabel().compareTo("end") == 0) {
			//Message.showMessage("Im[h͍폜ł܂B");
			Message.showMessage("You can not delete the node.");
		} else {
			delNode.getNext().setBack(delNode.getBack());
			//System.out.println("delnode: " + delNode.getBack().getNodeLabel());
			delNode.getBack().setNext(delNode.getNext());

			//TempNode.deleteLink(delNode.getNodeID());
			TempNode.deleteLink(delNode);

			//if (delNode.getBack().getNodeLabel() != null)
			//	System.out.println("Om[h:" + delNode.getBack().getNodeLabel());
			delNode.getBack().setNext(delNode.getNext());
			//if (delNode.getNext().getNodeLabel() != null)
			//	System.out.println("m[h:" + delNode.getNext().getNodeLabel());

		}

	}

	/**
	 * nꂽnodeIDN폜
	 * @param delNode 폜Ώۃm[h
	 * @param nodeID 
	 */
	private static void deleteLink(TempNode delNode) {
		work = TempNode.getRoot();
		//폜Ώۃm[h̐em[h̎qID̍폜
		if (delNode.getParentNum() != -1) {
			work = TempNode.searchTempNode(delNode.getParentNum());
			if (work != null) {
				work.setChild_num(-1);
			}
		}
		TempEdge.delete(delNode.getNodeID(), work.getNodeID());
		work = null;

		if (delNode.getChildNum() != -1) {
			work = TempNode.searchTempNode(delNode.getChildNum());
			if (work != null)
				work.setParentNum(-1);
		}

		if (work != null)
			TempEdge.delete(delNode.getNodeID(), work.getNodeID());
		work = null;

		//폜Ώۃm[ȟZm[h̒ID̍폜
		if (delNode.getOldBrotherNum() != -1) {
			work = TempNode.searchTempNode(delNode.getOldBrotherNum());
			if (work != null) {
				if (work.getYoungerBrotherNum() == delNode.getNodeID()) {
					work.setYoungerBrotherNum(-1);
				}
			}
		}
		if (work != null)
			TempEdge.delete(delNode.getNodeID(), work.getNodeID());
		work = null;

		//폜Ώۃm[h̒m[ȟZID̍폜
		if (delNode.getYoungerBrotherNum() != -1) {
			work = TempNode.searchTempNode(delNode.getYoungerBrotherNum());
			if (work != null) {
				if (work.getOldBrotherNum() == delNode.getNodeID()) {
					work.setOldBrotherNum(-1);
				}
			}
		}
		if (work != null)
			TempEdge.delete(delNode.getNodeID(), work.getNodeID());
	}

	/**
	 * ͐`XgɈœnꂽNbN|CgZ邩ǂ
	 */
	public static TempNode searchTempNode(Point clickPoint) {
		work = TempNode.getRoot().getNext();
		while (work.getNodeLabel().compareTo("end") != 0) {
			rectangle = new Rectangle(work.getDrawPoint().x, work.getDrawPoint().y, work.getNodeSize().x, work.getNodeSize().y);
			if (work.getNodeTypeNumber() != -1 && (rectangle.contains(clickPoint.x, clickPoint.y))) {
				State.setNodeHitID(work.getNodeID());
				return work;
			}
			if (work.getNext() == null)
				work = null;
			else
				work = work.getNext();
		}
		work = null;
		return work;
	}

	/**
	 * ͐`XgɈœnꂽnodeIDZ邩ǂ
	 */
	public static TempNode searchTempNode(int nodeID) {
		work = TempNode.getRoot();
		while (work.getNodeLabel().compareTo("end") != 0) {
			if (work.getNodeID() == nodeID) {
				State.setNodeHitID(work.getNodeID());
				return work;
			}
			if (work.getNext() == null)
				work = null;
			else
				work = work.getNext();
		}
		work = null;
		return work;
	}

	/**
	 * ͐`XgendZ
	 */
	public static void searchEndNode() {
		work = TempNode.getRoot();
		while (true) {
			System.out.println("work.nodeLabel " + work.nodeLabel);
			if (work.getNodeLabel().compareTo("end") == 0) {
				TempNode.setEndNode(work);
				break;
			}
			work = work.getNext();
		};
	}

	/**
	 * ͂̐`Xgꗗ\
	 */
	public static final void Print_Temp_Node() {
		work = TempNode.getRoot();
		while (work.getNodeLabel().compareTo("end") != 0) {
			System.out.println("ID: " + work.getNodeID());
			System.out.println("nodelabel: " + work.getNodeLabel());
			System.out.println("nodepoint.x: " + work.drawPoint.x);
			System.out.println("nodepoint.y: " + work.drawPoint.y);
			System.out.println("parent: " + work.getParentNum());
			System.out.println("child: " + work.getChildNum());
			System.out.println("old_brother: " + work.getOldBrotherNum());
			System.out.println("younger_brother: " + work.getYoungerBrotherNum() + "\n");
			if (work.getNext() == null)
				work = null;
			else
				work = work.getNext();
		}
	}

	/**
	 * ͐`XgAHichart؍\ɕϊ
	 */
	public boolean ttoh(HichartNode hn, TempNode tn) {
		tn = TempNode.searchTempNode(hn.getNodeID());
		if (tn == null) {
			return false;
		} else {
			hn.setNodeTypeNumber(tn.getNodeTypeNumber());
			hn.getDrawPoint().x = tn.getDrawPoint().x;
			hn.getDrawPoint().y = tn.getDrawPoint().y;
			hn.getNodeSize().x = tn.getNodeSize().x;
			hn.getNodeSize().y = tn.getNodeSize().y;
			hn.setNodeLabel(tn.getNodeLabel());

			if (tn.getChildNum() != -1) {

				hn.setChild1(new HichartNode());
				hn.getChild1().setParent(hn);
				hn.getChild1().setNodeID(tn.getChildNum());
				hn.getChild1().setRoot(hn.getRoot());
			}

			//Z֌W쐬
			if (tn.getYoungerBrotherNum() != -1) {
				hn.setYoungerBrother(new HichartNode());
				hn.getYoungerBrother().setOlderBrother(hn);
				hn.getYoungerBrother().setNodeID(tn.getYoungerBrotherNum());
				hn.getYoungerBrother().setRoot(hn.getRoot());
			}
		}

		if (hn.getChild1() != null)
			ttoh(hn.getChild1(), tn);
		if (hn.getChild2() != null)
			ttoh(hn.getChild2(), tn);
		if (hn.getYoungerBrother() != null)
			ttoh(hn.getYoungerBrother(), tn);

		return true;
	}

	/**
	 * `̈̌vZ
	 * @return Dimension `̈
	 */
	public static Dimension calDrawArea() {
		Dimension size = new Dimension(0, 0);
		TempNode work = null;
		work = TempNode.getRoot().getNext();

		while (work.getNodeLabel().compareTo("end") != 0) {
			if (work.getDrawPoint().getX() + work.getNodeSize().getX() > size.getWidth()) {
				size.width = (int) (work.getDrawPoint().getX() + work.getNodeSize().getX() + 20);
			}

			if (work.getDrawPoint().getY() + work.getNodeSize().getY() > size.getHeight()) {
				size.height = (int) (work.getDrawPoint().getY() + work.getNodeSize().getY() + 20);
			}

			if (work.getNext() == null)
				work = null;
			else
				work = work.getNext();
		}

		return size;
	}

	/**
	 * ZTCY̌vZ
	 */
	public void calcNodeSize(Graphics g) {
		if (this.getNodeLabel() != null && this.getNodeLabel().length() != 0) {

			Graphics2D g2 = (Graphics2D) g;
			Font f1 = new Font("Dialog", Font.PLAIN, 10);
			g2.setFont(f1);
			FontRenderContext fc1 = g2.getFontRenderContext();
			String str1 = this.getNodeLabel();
			//String str2 = this.getString();
			String str2 = this.getDispStr();
			String drawString = "";

			int str2Max = 0;

			int tempHeight = State.ADJUST_Y;
			char ch;

			if (str2 != null && str2.compareTo("") != 0) {

				for (int i = 0; i < str2.length(); i++) {
					ch = str2.charAt(i);

					if (ch == '\n' || i == str2.length() - 1) {
						tempHeight += State.ROWGAP;

						if (getNodeSize().y <= tempHeight)
							this.setNodeSizeY(tempHeight);

						if (drawString != null && drawString.compareTo("") != 0) {
							TextLayout tl2 = new TextLayout(drawString, f1, fc1);
							Rectangle2D r2 = tl2.getBounds();

							if (str2Max < r2.getWidth())
								str2Max = (int) r2.getWidth();
						}
						drawString = "";
					} else {
						drawString += ch;
					}

				}
			}
			this.getNodeSize().x = str2Max + this.getLeftMargin() + this.getRightMargin() + State.MARGIN + State.MARGIN;

			if (this.nodeSize.x < State.getDefaultNodeWidth())
				this.setNodeSizeX(State.getDefaultNodeWidth());

			if (this.nodeSize.y < State.getDefaultNodeHeight())
				this.nodeSize.y = State.getDefaultNodeHeight();

		}

	}

	// ================================ Qb^[ƃZb^[ ================================//
	//rootm[h̃Zbg
	private void setRootNode() {
		this.setNext(new TempNode());
		this.setNodeTypeNumber(0);
		this.setNodeID(0);
		this.getDrawPoint().x = 0;
		this.getDrawPoint().y = 0;
		this.getNodeSize().x = 1;
		this.getNodeSize().y = 1;
		this.setNodeLabel("root");
		root = this;
	}
	public static void setRootNode(TempNode rootNode) {
		root = rootNode;
	}

	//endm[h̃Zbg
	private void setEndNode() {
		end = new TempNode();
		end.setNodeTypeNumber(0);
		end.setNodeID(0);
		end.getDrawPoint().x = 0;
		end.getDrawPoint().y = 0;
		end.getNodeSize().x = 1;
		end.getNodeSize().y = 1;
		end.setNodeLabel("end");
		root.getNext().setNext(end);
		end.setBack(root.getNext());
	}

	public static void setEndNode(TempNode endNode) {
		end = endNode;
	}

	public static TempNode getRoot() {
		return root;
	}

	public static TempNode getEnd() {
		return end;
	}

	public void setDrawPoint(Point ptnode) {
		this.drawPoint = ptnode;
	}

	public Point getDrawPoint() {
		return drawPoint;
	}

	public void setDrawPointX(int X) {
		this.drawPoint.x = X;
	}
	public void setDrawPointY(int Y) {
		this.drawPoint.y = Y;
	}

	public void setNodeSize(Point nodesize) {
		this.nodeSize = nodesize;
	}

	public Point getNodeSize() {
		return nodeSize;
	}

	public void setNodeSizeX(int X) {
		this.nodeSize.x = X;
	}

	public void setNodeSizeY(int Y) {
		this.nodeSize.y = Y;
	}

	public void setNodeID(int nodeID) {
		this.nodeID = nodeID;
	}

	public int getNodeID() {
		return this.nodeID;
	}

	public void setNodeTypeNumber(int nodeTypeNumber) {
		NodeTypeNumber = nodeTypeNumber;
	}

	public int getNodeTypeNumber() {
		return NodeTypeNumber;
	}

	public void setNodeLabel(String nodeLabel) {
		this.nodeLabel = nodeLabel;
	}

	public String getNodeLabel() {
		return nodeLabel;
	}

	public void setParentNum(int parent_num) {
		this.parentNum = parent_num;
	}

	public int getParentNum() {
		return parentNum;
	}

	public void setChild_num(int child_num) {
		this.childNum = child_num;
	}
	public int getChildNum() {
		return this.childNum;
	}

	public void setOldBrotherNum(int old_brother_num) {
		this.oldBrotherNum = old_brother_num;
	}

	public int getOldBrotherNum() {
		return oldBrotherNum;
	}

	public void setYoungerBrotherNum(int younger_brother_num) {
		this.youngerBrotherNum = younger_brother_num;
	}

	public int getYoungerBrotherNum() {
		return youngerBrotherNum;
	}

	public void setString1(String string) {
		this.string1 = string;
	}

	public String getString1() {
		return string1;
	}

	public void setString2(String string) {
		this.string2 = string;
	}

	public String getString2() {
		return string2;
	}

	public void setNext(TempNode next) {
		this.next = next;
	}

	public TempNode getNext() {
		return this.next;
	}

	public void setBack(TempNode back) {
		this.back = back;
	}

	public TempNode getBack() {
		return this.back;
	}

	public void setLl(String ll) {
		this.ll = ll;
	}

	public String getLl() {
		return this.ll;
	}

	public void setCl(String cl) {
		this.cl = cl;
	}

	public String getCl() {
		return this.cl;
	}

	public void setDispStr(String str) {
		this.dispStr = str;
	}

	public String getDispStr() {
		return this.dispStr;
	}

	public void setLeftMargin() {
		switch (this.getNodeTypeNumber()) {

			//`ςݏZ
			case 1 :
				this.leftMargin = State.DEFINED_LEFT;
				break;

				//oZ
			case 2 :
				this.leftMargin = State.TITLE_LEFT;
				break;

				//ėpZ
			case 3 :
				this.leftMargin = State.GENERAL_LEFT;
				break;

				//[qZ
			case 4 :
				this.leftMargin = State.TERMINAL_LEFT;
				break;

				//I𕪊Z
			case 5 :
				this.leftMargin = State.IF_LEFT;
				break;

				//񕪊Z
			case 6 :
				this.leftMargin = State.PARAIF_LEFT;
				break;

				//AZ
			case 7 :
				this.leftMargin = State.REPEAT_LEFT;
				break;

				//O^Z
			case 8 :
				this.leftMargin = State.PRETEST_LEFT;
				break;

				//㔻^Z
			case 9 :
				this.leftMargin = State.POSTTEST_LEFT;
				break;
		}
	}

	public int getLeftMargin() {
		return this.leftMargin;
	}

	public void setRightMargin() {
		switch (this.getNodeTypeNumber()) {

			//`ςݏZ
			case 1 :
				this.rightMargin = State.DEFINED_RIGHT;
				break;

				//oZ
			case 2 :
				this.rightMargin = State.TITLE_RIGHT;
				break;

				//ėpZ
			case 3 :
				this.rightMargin = State.GENERAL_RIGHT;
				break;

				//[qZ
			case 4 :
				this.rightMargin = State.TERMINAL_RIGHT;
				break;

				//I𕪊Z
			case 5 :
				this.rightMargin = State.IF_RIGHT;
				break;

				//񕪊Z
			case 6 :
				this.rightMargin = State.PARAIF_RIGHT;
				break;

				//AZ
			case 7 :
				this.rightMargin = State.REPEAT_RIGHT;
				break;

				//O^Z
			case 8 :
				this.rightMargin = State.PRETEST_RIGHT;
				break;

				//㔻^Z
			case 9 :
				this.rightMargin = State.POSTTEST_RIGHT;
				break;
		}
	}

	public int getRightMargin() {
		return this.rightMargin;
	}

	public Vector getChildren() {
		Vector children = new Vector();
		TempNode current = this;

		if (current.getChildNum() == -1)
			children = null;
		else {
			current = TempNode.searchTempNode(current.getChildNum());
			children.add(current);

			while (current.getYoungerBrotherNum() != -1) {
				current = TempNode.searchTempNode(current.getYoungerBrotherNum());
				children.add(current);
				//System.out.println("Zǉ ID: "+ current.getNodeID() + " label: "+current.getNodeLabel());
			}
		}
		return children;
	}

	public Vector getYoungerBrothers() {
		Vector youngerBrothers = new Vector();
		TempNode current = this;

		youngerBrothers.add(current);
		if (current.getYoungerBrotherNum() == -1)
			youngerBrothers = null;
		else {
			current = TempNode.searchTempNode(current.getYoungerBrotherNum());
			youngerBrothers.add(current);

			while (current.getYoungerBrotherNum() != -1) {
				current = TempNode.searchTempNode(current.getYoungerBrotherNum());
				youngerBrothers.add(current);
				//System.out.println("Zǉ ID: "+ current.getNodeID() + " label: "+current.getNodeLabel());
			}
		}
		return youngerBrothers;
	}

}