package hicharted.event.inputNodeInfo;

import hicharted.dataStructure.TempNode;
import hicharted.hcpgg.*;

/**
 * \̐ݒ
 * 
 *
 */
public class DisplayString {
	String word1 = "";
	String word2 = "";

	/**
	 * m[hx\
	 * @param current Ώۂ̃m[h
	 * @return \
	 */
	public String getDispNodeLabel(TempNode current) {
		String returnStr = "";

		returnStr = Integer.toString(current.getNodeID());
		returnStr = returnStr + "\n";
		returnStr = returnStr + current.getNodeLabel();

		return returnStr;
	}

	/**
	 * DXLLq\
	 * @param current Ώۂ̃m[h
	 * @return \
	 */
	public String getDispDXLDescription(TempNode current) {
		String returnStr = "";

		switch (PrecedenceRelation.toNumber(current.getNodeLabel())) {
			case 101 : //m_packet
				returnStr = "M_Packet";
				break;

			case 102 : //profile
				returnStr = "Profile";
				break;

			case 103 : //identifier_is
				returnStr = "Identifier is" + "\n" + current.getString1();
				break;

			case 104 : //explanation
				returnStr = current.getString1();
				break;

			case 105 : //module_algorithm
				returnStr = "Module_Algorithm";
				break;

			case 106 : //empty_statement_list
				returnStr = "";
				break;

			case 107 : //statement_head
				returnStr = "";
				break;

			case 108 : //label
				returnStr = current.getString1();
				break;

			case 109 : //imperative
				returnStr = "imperative" + "\n" + current.getString1();
				break;

			case 110 : //imperative_null
				returnStr = "imperative\nnull" + current.getString1();
				break;

			case 111 : //imperative_call
				returnStr = "imperative\ncall\n" + current.getString1() + "\n" + current.getString2();
				break;

			case 112 : //imperative_goto
				returnStr = "imperative goto " + current.getString1() + "\n" + current.getString2();
				;
				break;

			case 113 : //block_identifier
				returnStr = current.getString1();
				break;

			case 114 : //abstract
				returnStr = "abstract";
				break;

			case 115 : //block_specification
				returnStr = current.getString1();
				break;

			case 116 : //begin
				returnStr = "begin";
				break;

			case 117 : //parallel
				returnStr = "parallel";
				break;

			case 118 : //pre_condition_for
				returnStr = "condition\nfor\n" + current.getString1();
				break;

			case 119 : //pre_condition_until
				returnStr = "condition\nuntil\n" + current.getString1();
				break;

			case 120 : //pre_condition_while
				returnStr = "condition\nwhile\n" + current.getString1();
				break;

			case 121 : //pre_condition
				returnStr = "condition\n" + current.getString1();
				break;

			case 122 : //post_condition_while
				returnStr = "condition\nwhile\n" + current.getString1();
				break;

			case 123 : //post_condition_until
				returnStr = "condition\nuntil\n" + current.getString1();
				break;

			case 124 : //post_condition
				returnStr = "condition\n" + current.getString1();
				break;

			case 125 : //loop
				returnStr = "loop";
				break;

			case 126 : //monadic_if_then
				returnStr = "if\n" + current.getString1();
				break;

			case 127 : //branch_dummy
				returnStr = "";
				break;

			case 128 : //if_then
				returnStr = "if\n" + current.getString1();
				break;

			case 129 : //else_if_then
				returnStr = "else_if\n" + current.getString1();
				break;

			case 130 : //ex_case
				returnStr = "case\n" + current.getString1();
				;
				break;

			case 131 : //in_case
				returnStr = "case\n" + current.getString1();
				;
				break;

			case 132 : //empty_when_statement
				returnStr = "";
				break;

			case 133 : // choice_specification
				returnStr = "";
				break;

			case 134 : //terminate_system
				returnStr = "terminate\nsystem\n" + current.getString1();
				break;

			case 135 : //terminate_module
				returnStr = "terminate\nmodule\n" + current.getString1();
				break;

			case 136 : //terminate_block
				returnStr = "terminate\nblock\n" + current.getString1() + "\n" + current.getString2();
				break;

			case 137 : //true
				break;

			case 138 : //false
				break;
		}
		return returnStr;
	}
}
