package hicharted.event.inputNodeInfo;

import hicharted.dataStructure.*;
import hicharted.*;
import hicharted.hcpgg.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

/**
 * m[h͉
 * 
 *
 */
public class InputNodeInfo extends JDialog {
	private JTextArea ta1, ta2;
	private Vector listitems;
	private JButton tb1, tb2;
	private JPanel panel2, panel3;
	private JLabel label1 = new JLabel();
	private JLabel label2 = new JLabel();
	private JLabel label3 = new JLabel();
	private TempNode current;
	JScrollPane scr1, scr2;
	final JComboBox combo;

	public InputNodeInfo() {
		this.setTitle("Input cell infromation");
		this.setSize(400, 450);
		this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);

		Container cont = getContentPane();
		panel2 = new JPanel(new FlowLayout(FlowLayout.CENTER));
		((FlowLayout) panel2.getLayout()).setHgap(1000);

		//eLXg{bNXݒ
		ta1 = new JTextArea(5, 10);
		scr1 = new JScrollPane(ta1);
		scr1.setPreferredSize(new Dimension(300, 150));

		ta2 = new JTextArea(5, 10);
		scr2 = new JScrollPane(ta2);
		scr2.setPreferredSize(new Dimension(300, 150));

		//R{{bNXXgݒ
		listitems = new Vector();

		combo = new JComboBox(listitems);
		combo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setLabel();
				setTextArea();
			}
		});
		panel2.add(combo, "North");

		panel3 = new JPanel();
		panel3.setLayout(new BoxLayout(panel3, BoxLayout.Y_AXIS));
		label1.setAlignmentX(0.5f);
		panel3.add(label1);
		label2.setAlignmentX(0.5f);
		panel3.add(label2);
		panel3.add(scr1);
		label3.setAlignmentX(0.5f);
		panel3.add(label3);
		panel3.add(scr2);
		panel2.add(panel3);

		//OK{^
		JPanel top = new JPanel();

		top.add(tb1 = new JButton("OK"));
		tb1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				okButtonPressed();
				setVisible(false);
			}
		});

		//LZ{^
		top.add(tb2 = new JButton("LZ"));
		tb2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
			}
		});

		cont.add(panel2, "Center");
		cont.add(top, "South");

	}

	/**
	 * OK{^
	 *
	 */
	private void okButtonPressed() {
		current.setNodeLabel((String) combo.getSelectedItem());
		if (ta1.getText().compareTo("") != 0)
			current.setString1(ta1.getText());
		else
			current.setString1("");

		if (ta2.getText().compareTo("") != 0)
			current.setString2(ta2.getText());
		else
			current.setString2("");

		DisplayString rw = new DisplayString();
		String dispStr = "";
		//\ʂɂAi[ύX
		if (State.getDispType() == 0) //m[hx\
			dispStr = rw.getDispNodeLabel(current);
		else //DXL\ 
			dispStr = rw.getDispDXLDescription(current);

		current.setDispStr(dispStr);
		Graphics g = this.getGraphics();
		current.setNodeSize(new Point(State.getDefaultNodeWidth(), State.getDefaultNodeHeight()));
		current.calcNodeSize(g);
	}

	/**
	 * 
	 * 
	 *
	 */
	public void initialize(TempNode temp) {
		setPlacement();
		current = temp;

		//O
		this.setListItem(current.getNodeTypeNumber());
		combo.setSelectedIndex(0);

		tb2.setEnabled(false);
		this.setVisible(true);
	}

	/**
	 * m[h͉ʂ̕\
	 * @param temp ͑Ώۂ̃m[h
	 */
	public void showDialog(TempNode temp) {
		setPlacement();
		current = temp;

		//O
		this.setListItem(current.getNodeTypeNumber());
		//m[hIɃxƕݒ肵ĂꍇAlƂĐݒ
		if (current.getNodeLabel().compareTo("") != 0)
			combo.setSelectedIndex(listitems.indexOf(current.getNodeLabel()));

		if (current.getString1() != null)
			ta1.setText(current.getString1());

		if (current.getString2() != null)
			ta2.setText(current.getString2());
		setLabel();
		setTextArea();
		//EBhE̕\
		this.setVisible(true);
	}

	/**
	 * EChE̕\ʒuݒ(EBhE𒆉ɔzu)
	 *
	 */
	private void setPlacement() {
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension thisSize = this.getSize();
		if (thisSize.height > screenSize.height) {
			thisSize.height = screenSize.height;
		}
		if (thisSize.width > screenSize.width) {
			thisSize.width = screenSize.width;
		}

		this.setLocation((screenSize.width - thisSize.width) / 2, (screenSize.height - thisSize.height) / 2);
	}

	/**
	 * IXgɃm[hx̖̂ݒ
	 *
	 */
	private void setLabel() {
		String currentNodeLabel = (String) combo.getSelectedItem();
		switch (PrecedenceRelation.toNumber(currentNodeLabel)) {
			case 101 : //m_packet
				label1.setText("M_Packet");
				label2.setText("");
				label3.setText("");
				break;

			case 102 : //profile
				label1.setText("Profile");
				label2.setText("");
				label3.setText("");
				break;
			case 103 : //identifier_is
				label1.setText("Identifier is");
				label2.setText("");
				label3.setText("");
				break;
			case 104 : //explanation
				label1.setText("");
				label2.setText("");
				label3.setText("");
				break;

			case 105 : //module_algorithm
				label1.setText("Module_Algorithm");
				label2.setText("");
				label3.setText("");
				break;

			case 106 : //empty_statement_list
				label1.setText("");
				label2.setText("");
				label3.setText("");
				break;
			case 107 : //statement_head
				label1.setText("");
				label2.setText("");
				label3.setText("");
				break;
			case 108 : //label
				label1.setText("");
				label2.setText("");
				label3.setText("");
				break;
			case 109 : //imperative
				label1.setText("imperative");
				label2.setText("");
				label3.setText("");
				break;
			case 110 : //imperative_null
				label1.setText("imperative");
				label2.setText("null");
				label3.setText("");
				break;
			case 111 : //imperative_call
				label1.setText("imperative");
				label2.setText("call");
				label3.setText("");
				break;
			case 112 : //imperative_goto
				label1.setText("imperative");
				label2.setText("goto");
				label3.setText("");
				break;
			case 113 : //block_identifier
				label1.setText("");
				label2.setText("");
				label3.setText("");
				break;
			case 114 : //abstract
				label1.setText("");
				label2.setText("");
				label3.setText("");
				break;
			case 115 : //block_specification
				label1.setText("");
				label2.setText("");
				label3.setText("");
				break;
			case 116 : //begin
				label1.setText("begin");
				label2.setText("");
				label3.setText("");
				break;
			case 117 : //parallel
				label1.setText("parallel");
				label2.setText("");
				label3.setText("");
				break;
			case 118 : //pre_condition_for
				label1.setText("condition");
				label2.setText("for");
				label3.setText("");
				break;
			case 119 : //pre_condition_until
				label1.setText("condition");
				label2.setText("until");
				label3.setText("");
				break;
			case 120 : //pre_condition_while
				label1.setText("condition");
				label2.setText("while");
				label3.setText("");
				break;
			case 121 : //pre_condition
				label1.setText("condition");
				label2.setText("");
				label3.setText("");
				break;
			case 122 : //post_condition_while
				label1.setText("condition");
				label2.setText("while");
				label3.setText("");
				break;
			case 123 : //post_condition_until
				label1.setText("condition");
				label2.setText("until");
				label3.setText("");
				break;
			case 124 : //post_condition
				label1.setText("condition");
				label2.setText("");
				label3.setText("");
				break;
			case 125 : //loop
				label1.setText("loop");
				label2.setText("");
				label3.setText("");
				break;
			case 126 : //monadic_if_then
				label1.setText("if");
				label2.setText("");
				label3.setText("");
				break;
			case 127 : //branch_dummy
				label1.setText("");
				label2.setText("");
				label3.setText("");
				break;
			case 128 : //if_then
				label1.setText("if");
				label2.setText("");
				label3.setText("");
				break;
			case 129 : //else_if_then
				label1.setText("else_if");
				label2.setText("");
				label3.setText("");
				break;
			case 130 : //exclusive_case
				label1.setText("case");
				label2.setText("");
				label3.setText("");
				break;
			case 131 : //inclusive_case
				label1.setText("case");
				label2.setText("");
				label3.setText("");
				break;
			case 132 : //empty_when_statement
				label1.setText("");
				label2.setText("");
				label3.setText("");
				break;
			case 133 : //choice_specification
				label1.setText("");
				label2.setText("");
				label3.setText("");
				break;
			case 134 : //terminate_system
				label1.setText("terminate");
				label2.setText("system");
				label3.setText("");
				break;
			case 135 : //terminate_module
				label1.setText("terminate");
				label2.setText("module");
				label3.setText("");
				break;

			case 136 : //terminate_block
				label1.setText("terminate");
				label2.setText("block");
				label3.setText("");
				break;

			case 137 : //true
				label1.setText("");
				label2.setText("");
				label3.setText("");
				break;
			case 138 : //false
				label1.setText("");
				label2.setText("");
				label3.setText("");
				break;

		}
	}

	/**
	 * eLXgGA̐ݒ
	 *
	 */
	private void setTextArea() {
		String currentNodeLabel = (String) combo.getSelectedItem();
		switch (PrecedenceRelation.toNumber(currentNodeLabel)) {
			case 101 : //m_packet
			case 102 : //profile
			case 105 : //module_algorithm
			case 106 : //empty_statement_list
			case 107 : //statement_head
			case 114 : //abstract
			case 116 : //begin
			case 117 : //parallel
			case 125 : //loop
			case 127 : //branch_dummy
			case 132 : //empty_when_statement
			case 137 : //true
			case 138 : //false 
				ta1.setEnabled(false);
				ta1.setText("");
				ta1.setBackground(Color.LIGHT_GRAY);
				ta2.setEnabled(false);
				ta2.setText("");
				ta2.setBackground(Color.LIGHT_GRAY);
				break;

			case 103 : //identifier_is
			case 104 : //explanation
			case 108 : //label
			case 109 : //imperative
			case 110 : //imperative_null
			case 113 : //block_identifier
			case 115 : //block_specification
			case 118 : //pre_condition_for
			case 119 : //pre_condition_until
			case 120 : //pre_condition_while
			case 121 : //pre_condition
			case 122 : //post_condition_while
			case 123 : //post_condition_until
			case 124 : //post_condition
			case 126 : //monadic_if_then
			case 128 : //if_then
			case 129 : //else_if_then
			case 130 : //exclusive_case
			case 131 : //inclusive_case
			case 133 : //choice_specification
			case 134 : //terminate_system
			case 135 : //terminate_module
				ta1.setEnabled(true);
				ta1.setBackground(Color.WHITE);
				ta2.setEnabled(false);
				ta2.setText("");
				ta2.setBackground(Color.LIGHT_GRAY);
				break;

			case 111 : //imperative_call
			case 112 : //imperative_goto
			case 136 : //terminate_block
				ta1.setEnabled(true);
				ta1.setBackground(Color.WHITE);
				ta2.setEnabled(true);
				ta2.setBackground(Color.WHITE);
				break;

		}
	}

	/**
	 * R{Xgxݒ
	 */
	private void setListItem(int nodetype) {
		switch (nodetype) {
			//ꏊ`ςݔėpZ̎
			case 1 :
				listitems.add("identifier_is");
				listitems.add("module_algorithm");
				listitems.add("m_packet");
				listitems.add("block_identifier");
				listitems.add("boxempty2");
				listitems.add("boxempty3");
				listitems.add("imperative_call");
				break;

				//ꏊoZ̎
			case 2 :
				listitems.add("profile");
				listitems.add("abstract");
				break;

				//ꏊėpZ̏ꍇ
			case 3 :
				listitems.add("explanation");
				listitems.add("empty_statement_list");
				listitems.add("block_specification");
				listitems.add("imperative");
				listitems.add("imperative_null");
				listitems.add("imperative_call");
				listitems.add("imperative_goto");
				listitems.add("label");
				listitems.add("choice_specification");
				listitems.add("statement_head");
				listitems.add("true");
				listitems.add("false");
				listitems.add("empty_when_statement");
				break;

				//ꏊ[qZ̏ꍇ
			case 4 :
				listitems.add("terminate_system");
				listitems.add("terminate_block");
				listitems.add("terminate_module");
				listitems.add("imperative_goto");
				break;

				//ꏊ򕪊Z̏ꍇ
			case 5 :
				listitems.add("if_then");
				listitems.add("monadic_if_then");
				listitems.add("else_if_then");
				listitems.add("exclusive_case");
				break;

				//ꏊ񕪊Z̎
			case 6 :
				listitems.add("parallel");
				listitems.add("inclusive_case");
				break;

				//ꏊAZ̏ꍇ
			case 7 :
				//listitems.add("boxempty3");
				listitems.add("loop");
				listitems.add("begin");
				break;

				//ꏊO^Z
			case 8 :
				listitems.add("pre_condition_for");
				listitems.add("pre_condition_until");
				listitems.add("pre_condition_while");
				listitems.add("pre_condition");
				break;

				//ꏊ㔻^Z
			case 9 :
				listitems.add("post_condition_while");
				listitems.add("post_condition_until");
				listitems.add("post_condition");
				break;

				//_~[Z
			case 10 :
				listitems.add("dummy");
				break;

			case 0 :
			default :
				listitems.add("Ώۃx");
				break;
		}
	}

}