package hicharted.hcpgg;

import hicharted.dataStructure.*;

public class P50 extends Production {
	public P50() {
		this.setRuleNo(50);
		HichartNode lhs = new HichartNode();
		HichartNode rhs = new HichartNode();

		//left hand side
		lhs.setNodeLabel("Selective_statement");
		lhs.setNodeID(0);
		this.setLhs(lhs);

		//right hand side
		rhs.setNodeLabel("Inclusive_select_statement");
		rhs.setNodeID(1);
		this.setRhs(rhs);
	}

	public void coordinateAttCalcI(TreeNode n) {
		n.setX1(n.getX0());
		n.setTop1(n.getTop0());

		n.getChildren1().setX0(n.getX1());
		n.getChildren1().setTop0(n.getTop1());
	}

	public void coordinateAttCalcS(TreeNode n) {
		//n.setY1(n.getTop0());
		n.setY0(n.getY1());
		n.setBottom1(n.getY1() + n.getH1());
		n.setBottom0(n.getBottom1());

		n.getParent().setY2(n.getY0());
		n.getParent().setBottom2(n.getBottom0());

		//y2,bottom2,y3,bottom3m[h͂̐Kɂ݂͑Ȃ0ŏ
		n.setY2(n.setBottom2(n.setY3(n.setBottom3(0))));
	}

	public void genSvg(TreeNode n) {
		n.setSSvg1(n.getChildren1().getSSvg0());
		n.setSSvg0(n.getSSvg1());
	}
	public void cyclomaticCalc(TreeNode n) {
		if (n.getChildren1() != null) {
			n.setCy1(n.getChildren1().getCy0());
		}
		n.setCy0(n.getCy1());
	}
}