package hicharted.hcpgg;

import hicharted.dataStructure.*;

public class P55 extends Production {
	public P55() {
		this.setRuleNo(55);
		HichartNode lhs = new HichartNode();
		HichartNode rhs = new HichartNode();

		//left hand side
		lhs.setNodeLabel("Else_if_statement");
		lhs.setNodeID(0);
		this.setLhs(lhs);

		//right hand side
		rhs.setNodeLabel("Statement_list");
		rhs.setNodeID(1);
		this.setRhs(rhs);
	}

	public void coordinateAttCalcI(TreeNode n) {
		n.setX1(n.getX0());
		n.setTop1(n.getTop0());

		n.getChildren1().setX0(n.getX1());
		n.getChildren1().setTop0(n.getTop1());
	}

	public void coordinateAttCalcS(TreeNode n) {
		n.setY0(n.getY1());
		n.setBottom0(n.getBottom1());

		n.getParent().setY2(n.getY0());
		n.getParent().setBottom2(n.getBottom0());

		//x2,y2,top2,bottom2,x3,y3,top3,bottom3m[h͂̐Kɂ݂͑Ȃ0ŏ
		n.setX2(n.setY2(n.setTop2(n.setBottom2(n.setX3(n.setY3(n.setTop3(n.setBottom3(0))))))));
		n.setH1(n.getChildren1().getH1());
	}

	public void genSvg(TreeNode n) {
		n.setSSvg1(n.getChildren1().getSSvg0());
		n.setSSvg0(n.getSSvg1());
	}

	public void cyclomaticCalc(TreeNode n) {
		if (n.getChildren1() != null) {
			n.setCy1(n.getChildren1().getCy0());
		}
		n.setCy0(n.getCy1());
	}
}