/*
 * 쐬: 2005/08/04
 * XV:
 * 
 */
package hicharted.parser;

import hicharted.dataStructure.*;
import hicharted.hcpgg.*;
import java.util.*;

/**
 * \ؐ
 * 
 */
public class ParseTree {
	/**
	 * \ؐ
	 * @param hroot Hichart\
	 */
	public static void generateParseTree(HichartNode hroot) {
		//pSequencehashɕϊ
		HashMap sequenceHash = new HashMap(); 
		Sequence tempSequence = Sequence.getEnd().getBack();
		while (tempSequence.getLabel().compareTo("root") != 0) {
			sequenceHash.put(new Integer(tempSequence.getAfter().getNodeID()), (Object) tempSequence);
			tempSequence = tempSequence.getBack();
		}

		HashMap treeHash = new HashMap();
		treeHash.put(new Integer(0), TreeNode.getRoot());
		TreeNode.getRoot().setChildren1();
		treeHash.put(new Integer(Sequence.getEnd().getBack().getAfter().getNodeID()), TreeNode.getRoot().getChildren1());

		Sequence currentSequence = Sequence.getEnd().getBack();
		while (currentSequence.getLabel().compareTo("root") != 0) {
			//Sequenceo
			Sequence workSequence = (Sequence) sequenceHash.get(new Integer(currentSequence.getAfter().getNodeID()));

			//Ko
			TreeNode workTreeNode = (TreeNode) treeHash.get(new Integer(workSequence.getAfter().getNodeID()));

			//K̐ݒ
			workTreeNode.setProduction(workSequence.getProductionNumber());

			//؍\
			for (int i = 0; i < workSequence.getBefore().size(); i++) {
				//I[̂Ƃ
				if (PrecedenceRelation.judgeTerminal((HichartNode) workSequence.getBefore().get(i)) == 1) {
					//ΉHichartXgA\؂̃m[hHichartXgւ̃N쐬
					HichartNode htemp;
					HichartNode dummyHichartNode;
					dummyHichartNode = (HichartNode) workSequence.getBefore().get(i);
					htemp = hroot.searchHichartNode(hroot, dummyHichartNode.getNodeID());

					if (htemp != null) {
						workTreeNode.setHlink(htemp);
						//HichartXg̏\؂ɓ`d
						workTreeNode.setW1(workTreeNode.getHlink().getNodeSize().x);
						workTreeNode.setH1(workTreeNode.getHlink().getNodeSize().y);

						//ΉHichartXgA\؂̃m[hɐ`̓Xgւ̃N쐬
						TempNode dummyTempNode = new TempNode();
						dummyTempNode = TempNode.searchTempNode(dummyHichartNode.getNodeID());
						if (dummyTempNode != null) {
							workTreeNode.setTemplink(dummyTempNode);
						} else {
							System.out.println("Tempnode nullG[");
							return;
						}
					} else {
						System.out.println("htemp null " + dummyHichartNode.getNodeID() + "G[");
					}
				} else {
					if (workTreeNode.getChildren1() == null) {
						workTreeNode.setChildren1();
						workTreeNode.getChildren1().setParent(workTreeNode);
						HichartNode test = (HichartNode) workSequence.getBefore().get(i);
						workTreeNode.getChildren1().setAfter_temp(test.getNodeID());
						treeHash.put(new Integer(test.getNodeID()), workTreeNode.getChildren1());
					} else {
						workTreeNode.setChildren2();
						workTreeNode.getChildren2().setParent(workTreeNode);
						HichartNode test = (HichartNode) workSequence.getBefore().get(i);
						workTreeNode.getChildren2().setAfter_temp(test.getNodeID());
						treeHash.put(new Integer(test.getNodeID()), workTreeNode.getChildren2());
					}
				}
			}
			currentSequence = currentSequence.getBack();
		}
	}
}
