package hicharted;

import hicharted.attribute.*;
import hicharted.dataStructure.*;
import hicharted.event.*;
import hicharted.parser.*;
import hicharted.event.inputNodeInfo.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import java.io.*;

/**
 * GfB^
 * @version 1.0
 */

public class Frame1 extends JFrame {
	private JPanel contentPane;
	private JMenuBar jMenuBar1 = new JMenuBar();
	private JMenu jMenuFile = new JMenu();
	private JMenuItem jMenuFileExit = new JMenuItem();
	private JMenu jMenuHelp = new JMenu();
	private JMenu jMenuDisp = new JMenu();
	private JMenu jMenucommand = new JMenu();
	private JMenuItem jMenuHelpAbout = new JMenuItem();
	private JMenuItem mi01; //j[ACeuNewv
	private JMenuItem mi02; //j[ACeuParsev
	private JMenuItem mi03; //j[ACeuGenerate SVG Filev
	//private JMenuItem mi04; //j[ACeuSVGAj[Vv
	private JMenuItem mi05; //j[ACeuPrint Derivation Treev
	private JMenuItem mi06; //j[ACeuCyclomatic Complexityv
	private JRadioButtonMenuItem rbmi01; //WI{^ACeum[hxv
	private JRadioButtonMenuItem rbmi02; //WI{^ACeuDXLv

	private JToolBar jToolBar = new JToolBar();
	private JToolBar jToolBar2 = new JToolBar();
	private JButton jButton1 = new JButton();
	private JButton jButton2 = new JButton();
	private JButton jButton3 = new JButton();
	private JButton jButton4 = new JButton();
	private JButton jButton5 = new JButton();
	private JButton jButton6 = new JButton();
	private JButton jButton7 = new JButton();
	private JButton jButton8 = new JButton();
	private JButton jButton9 = new JButton();
	private JButton jButton10 = new JButton();
	private JButton jButton11 = new JButton();
	private JButton jButton12 = new JButton();
	private JButton jButton13 = new JButton();
	private JButton jButton14 = new JButton();
	private JButton jButton15 = new JButton();
	private JButton jButton16 = new JButton();

	private ImageIcon image1, image2, image3, image4, image5, image6, image7, image8, image9, image10, image11, image12, image13, image14, image15, image16;

	private BorderLayout borderLayout1 = new BorderLayout();
	private JScrollPane jScrollPane1 = new JScrollPane();
	private JFileChooser chooser = new JFileChooser();

	private TempNode temp;
	TreeNode tnroot = new TreeNode(); //\؂root̏
	TempNode tempnode_root = new TempNode(); //͂Ƀm[h΂`Xg̐擪
	TempEdge tempnodeedge_root = new TempEdge(); //̓GbWɑ΂`Xg̐擪
	Parser parser = new Parser(); //p[U[p
	SVGout svgout = new SVGout(); //SVGt@CNX
	OperationFrame1 ope = new OperationFrame1(); //Frame1}EX

	private static HichartPane jPanel1 = new HichartPane();

	/**
	* Frame1 NX̃RXgN^it[̃rhj
	*/
	public Frame1() {
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try {
			init();
			this.format();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/** 
	*  
	*/
	public void format() {
		tempnode_root = new TempNode();
		State.format();
		tempnode_root.format(); //tempnode_rootm[h̐ݒ
		tempnodeedge_root.format();
		this.setTitle("HichartEditor");
		//hichartList.setRoot();
	}

	/**
	 * R|[lg̏
	 */
	private void init() throws Exception {
		image1 = new ImageIcon(hicharted.Frame1.class.getResource("gif/openFile.gif"));
		image2 = new ImageIcon(hicharted.Frame1.class.getResource("gif/closeFile.gif"));
		image3 = new ImageIcon(hicharted.Frame1.class.getResource("gif/help.gif"));
		image4 = new ImageIcon(hicharted.Frame1.class.getResource("gif/1.gif"));
		image5 = new ImageIcon(hicharted.Frame1.class.getResource("gif/2.gif"));
		image6 = new ImageIcon(hicharted.Frame1.class.getResource("gif/3.gif"));
		image7 = new ImageIcon(hicharted.Frame1.class.getResource("gif/4.gif"));
		image8 = new ImageIcon(hicharted.Frame1.class.getResource("gif/5.gif"));
		image9 = new ImageIcon(hicharted.Frame1.class.getResource("gif/6.gif"));
		image10 = new ImageIcon(hicharted.Frame1.class.getResource("gif/7.gif"));
		image11 = new ImageIcon(hicharted.Frame1.class.getResource("gif/8.gif"));
		image12 = new ImageIcon(hicharted.Frame1.class.getResource("gif/9.gif"));
		image13 = new ImageIcon(hicharted.Frame1.class.getResource("gif/10.gif"));
		image14 = new ImageIcon(hicharted.Frame1.class.getResource("gif/11.gif"));
		//image15 = new ImageIcon(hicharted.Frame1.class.getResource("gif/dummy.gif"));
		image16 = new ImageIcon(hicharted.Frame1.class.getResource("gif/arrows.gif"));

		contentPane = (JPanel) this.getContentPane();
		contentPane.setLayout(borderLayout1);
		this.setSize(new Dimension(660, 400));
		this.setTitle("HichartEditor Ver1.0");

		/*
		 * j[ݒ
		 */
		jMenuFile.setText("File");
		jMenucommand.setText("Command");
		jMenuDisp.setText("View");
		jMenuFileExit.setText("Exit");

		jMenuFileExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuFileExit_actionPerformed(e);
			}
		});

		jMenuDisp.add(rbmi01 = new JRadioButtonMenuItem("Inner structure"));
		rbmi01.setSelected(true);
		rbmi01.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				State.setDispType(0);
				changeDispString();
				jPanel1.repaint();
			}
		});

		jMenuDisp.add(rbmi02 = new JRadioButtonMenuItem("Hichart/DXL"));
		rbmi02.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				State.setDispType(1);
				changeDispString();
				jPanel1.repaint();
			}
		});

		ButtonGroup group = new ButtonGroup();
		group.add(rbmi01);
		group.add(rbmi02);

		jMenuFile.add(mi01 = new JMenuItem("New"));
		mi01.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				format();
				frameAdjust();
			}
		});

		jMenucommand.add(mi02 = new JMenuItem("Parse"));
		mi02.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//\͂Ƒ]
				boolean flag = doParseAndAttEval();
				if (flag == false) {
					Message.showMessage("Parsing failed.");
					return;
				}
			}
		});

		jMenucommand.add(mi03 = new JMenuItem("Generate SVG File"));
		mi03.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//\͂Ƒ]
				boolean flag = doParseAndAttEval();

				if (flag == false) {
					Message.showMessage("Parsing failed");
					return;
				}

				//SVGt@CɊւ鏈
				chooser = new JFileChooser();
				chooser.setDialogType(JFileChooser.SAVE_DIALOG);
				chooser.setDialogTitle("Save");
				chooser.setCurrentDirectory(new File("."));
				chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
				chooser.addChoosableFileFilter(new SvgFilter());

				int result = chooser.showSaveDialog(null);
				File fileobj = chooser.getSelectedFile();

				if (result == JFileChooser.APPROVE_OPTION) {
					String nodeFileName = chooser.getSelectedFile().getAbsolutePath();
					//System.out.println("nodeFileName" + nodeFileName);

					if (nodeFileName.endsWith(".svg") == false) {
						nodeFileName = nodeFileName + ".svg";
					}

					svgout.preProcessing(nodeFileName);
					svgout.svg(TreeNode.getRoot().getChildren1());
					svgout.postProcessing();
				}
				frameAdjust();
			}
		});

		jMenucommand.add(mi05 = new JMenuItem("Print Derivation Tree"));
		mi05.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//\͂Ƒ]
				boolean flag = doParseAndAttEval();
				if (flag == false) {
					Message.showMessage("Parsing failed.");
					return;
				}

				DerivationTreeFrame dtframe = new DerivationTreeFrame();
				dtframe.display();
			}
		});

		jMenucommand.add(mi06 = new JMenuItem("Cyclomatic Complexity"));
		mi06.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//\͂Ƒ]
				boolean flag = doParseAndAttEval();
				if (flag == false) {
					Message.showMessage("Parsing failed.");
					return;
				}

				int complexity = TreeNode.getRoot().cy0 + 1;
				String dialogmessage = "@@@Cyclomatic Complexity = " + complexity;
				String dialogtitle = "Cyclomatic Complexity ";
				int dialogtype = JOptionPane.INFORMATION_MESSAGE;
				JOptionPane.showMessageDialog((Component) null, dialogmessage, dialogtitle, dialogtype);
			}
		});

		jMenuHelp.setText("Help");
		jMenuHelpAbout.setText("Version");
		jMenuHelpAbout.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuHelpAbout_actionPerformed(e);
			}
		});

		jMenuFile.add(jMenuFileExit);
		jMenuHelp.add(jMenuHelpAbout);
		jMenuBar1.add(jMenuFile);
		jMenuBar1.add(jMenuDisp);
		jMenuBar1.add(jMenucommand);
		jMenuBar1.add(jMenuHelp);
		this.setJMenuBar(jMenuBar1);

		/*
		 * {^ݒ
		 */

		jButton1.setToolTipText("Open");
		jButton1.setIcon(image1);
		jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				jButton1_mouseClicked(e);
				frameAdjust();
				changeDispString();
			}
		});

		jButton2.setToolTipText("Save");
		jButton2.setIcon(image2);
		jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				jButton2_mouseClicked(e);
			}
		});
		jButton3.setIcon(image3);
		jButton3.setToolTipText("Help");

		jButton4.setIcon(image4);
		jButton4.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(1);
				State.setEdgeType(0);
			}
		});
		jButton4.setToolTipText("pre-defined process");

		jButton5.setIcon(image5);
		jButton5.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(2);
				State.setEdgeType(0);
			}
		});
		jButton5.setToolTipText("caption");

		jButton6.setIcon(image6);
		jButton6.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(3);
				State.setEdgeType(0);
			}
		});
		jButton6.setToolTipText("process");

		jButton7.setIcon(image7);
		jButton7.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(4);
				State.setEdgeType(0);
			}
		});
		jButton7.setToolTipText("terminal");

		jButton8.setIcon(image8);
		jButton8.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(5);
				State.setEdgeType(0);
			}
		});
		jButton8.setToolTipText("exclusive selection");

		jButton9.setIcon(image9);
		jButton9.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(6);
				State.setEdgeType(0);
			}
		});
		jButton9.setToolTipText("inclusive selection");

		jButton10.setIcon(image10);
		jButton10.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(7);
				State.setEdgeType(0);
			}
		});
		jButton10.setToolTipText("continuous iteration");

		jButton11.setIcon(image11);
		jButton11.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(8);
				State.setEdgeType(0);
			}
		});
		jButton11.setToolTipText("pre-tested iteration");

		jButton12.setIcon(image12);
		jButton12.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(9);
				State.setEdgeType(0);
			}
		});
		jButton12.setToolTipText("post-tested iteration");

		jButton15.setIcon(image15);
		jButton15.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(10);
				State.setEdgeType(0);
			}
		});
		jButton15.setToolTipText("dummy");

		jButton13.setIcon(image13);
		jButton13.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(0);
				State.setEdgeType(1);
			}
		});
		jButton13.setToolTipText("edge parent-child");

		jButton14.setIcon(image14);
		jButton14.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(0);
				State.setEdgeType(2);
			}
		});
		jButton14.setToolTipText("edge older brother-younger brother");

		jButton16.setIcon(image16);
		jButton16.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				State.setNodeType(100);
				State.setEdgeType(0);
			}
		});
		jButton16.setToolTipText("move node");

		/*
		 * c[o[ݒ
		 */
		jToolBar.add(jButton1);
		jToolBar.add(jButton2);
		jToolBar.add(jButton3);
		jToolBar.addSeparator();
		jToolBar.add(jButton16);
		jToolBar.add(jButton4);
		jToolBar.add(jButton5);
		jToolBar.add(jButton6);
		jToolBar.add(jButton7);
		jToolBar.add(jButton8);
		jToolBar.add(jButton9);
		jToolBar.add(jButton10);
		jToolBar.add(jButton11);
		jToolBar.add(jButton12);
		//jToolBar.add(jButton15);
		jToolBar.add(jButton13);
		jToolBar.add(jButton14);
		contentPane.add(jToolBar, BorderLayout.NORTH);

		/*
		 * Paneli`GAj̐ݒ
		 */
		jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		jScrollPane1.getVerticalScrollBar().setUnitIncrement(10);
		jScrollPane1.getViewport().setBackground(Color.black);
		jScrollPane1.setEnabled(true);
		jPanel1.setPreferredSize(new Dimension(900, 900));

		jPanel1.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				jPanel1_mousePressed(e);
				jPanel1.repaint();
			}
			public void mouseReleased(MouseEvent e) {
				jPanel1_mouseReleased(e);
				jPanel1.repaint();
			}
			public void mouseEntered(MouseEvent e) {
				jPanel1.repaint();
			}
		});

		jPanel1.setBackground(Color.white);
		contentPane.setBackground(Color.white);
		contentPane.add(jScrollPane1, BorderLayout.CENTER);
		jScrollPane1.getViewport().add(jPanel1, null);
	}

	
	//[File|Exit]
	public void jMenuFileExit_actionPerformed(ActionEvent e) {
		System.exit(0);
	}
	//[wv|o[W]
	public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
		Frame1_AboutBox dlg = new Frame1_AboutBox(this);
		Dimension dlgSize = dlg.getPreferredSize();
		Dimension frmSize = getSize();
		Point loc = getLocation();
		dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
		dlg.setModal(true);
		dlg.pack();
		//dlg.show();
		dlg.setVisible(true);
	}

	//EBhEꂽƂɏI悤ɃI[o[Ch
	protected void processWindowEvent(WindowEvent e) {
		super.processWindowEvent(e);
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			jMenuFileExit_actionPerformed(null);
		}
	}

	void jButton1_mouseClicked(MouseEvent e) {
		chooser = new JFileChooser();
		chooser.setDialogType(JFileChooser.OPEN_DIALOG);
		chooser.setDialogTitle("Open");
		chooser.setCurrentDirectory(new File("."));
		chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		chooser.addChoosableFileFilter(new DatFilter());

		int result = chooser.showOpenDialog(null);
		File fileobj = chooser.getSelectedFile();

		if (result == JFileChooser.APPROVE_OPTION) {
			format();
			String nodeFileName = chooser.getSelectedFile().getAbsolutePath();

			if (nodeFileName.endsWith(".dat") == false) {
				nodeFileName = nodeFileName + ".dat";
			}

			int kekka = FileEvent.fileOpen(nodeFileName);
			if (kekka == 9) {
				format();
				frameAdjust();
			}

			State.setNodeNum(TempNode.getEnd().getBack().getNodeID() + 1);
			State.setEdgeNum(TempEdge.getEnd().getBack().getEdgeID() + 1);

			frameAdjust();
			this.setTitle("HichartEditor " + nodeFileName);

			//TempNode.Print_Temp_Node();
		}
	}

	void jButton2_mouseClicked(MouseEvent e) {
		chooser = new JFileChooser();
		chooser.setDialogType(JFileChooser.SAVE_DIALOG);
		chooser.setDialogTitle("Save");
		chooser.setCurrentDirectory(new File("."));
		chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		chooser.addChoosableFileFilter(new DatFilter());
		int result = chooser.showSaveDialog(null);
		File fileobj = chooser.getSelectedFile();

		if (result == JFileChooser.APPROVE_OPTION) {
			String nodeFileName = chooser.getSelectedFile().getAbsolutePath();
			if (nodeFileName.endsWith(".dat") == false) {
				nodeFileName = nodeFileName + ".dat";
			}

			FileEvent.fileSave(nodeFileName);
		}
	}

	//jPanel1Ń}EXNbNꂽ
	void jPanel1_mousePressed(MouseEvent e) {
		Point clickPoint = new Point();

		//DXL\̏ꍇ͕ҏWs
		if (State.getDispType() == 1) {
			Message.showMessage("You can not operate in Hichart/DXL mode.");
		} else {

			//jPanel1Ń}EX̍ꂽ
			if ((e.getModifiers() & InputEvent.BUTTON1_MASK) == InputEvent.BUTTON1_MASK) {
				State.setDownFlag(false);
				State.setMoveFlag(false);
				int width = jPanel1.getPreferredSize().width;
				int height = jPanel1.getPreferredSize().height;
				int newNodeID = -1;
				State.setNodeHitID(-1);
				int count = e.getClickCount();
				clickPoint.x = e.getX();
				clickPoint.y = e.getY();

				TempNode.searchTempNode(clickPoint);
				//NbNJEg1̎ANbNɃm[hꍇ
				if (count == 1 && State.getNodeHitID() != -1) {
					if (State.getNodeType() == 100) {
						State.setMoveFlag(true);
						//System.out.println("move");
					}
					State.setBefore(State.getNodeHitID());
				}

				//NbNJEg2i_uNbNj̎
				else if (count == 2 && State.getNodeType() > 0) {
					//NbNɃm[hȂꍇm[hǉ
					if (State.getNodeHitID() == -1) {
						newNodeID = TempNode.insert(clickPoint);

						temp = TempNode.searchTempNode(newNodeID);
						InputNodeInfo ini = new InputNodeInfo();
						ini.initialize(temp);

						if (jPanel1.getPreferredSize().width - 100 <= e.getX()) {
							width = e.getX() + temp.getNodeSize().x + 150;

						}
						if (jPanel1.getPreferredSize().height - 100 <= e.getY()) {
							height = e.getY() + temp.getNodeSize().y + 150;

						}
						frameAdjust();

					} else {
						Message.showMessage("You can not put a node there.");
					}
				}

				//jPanel1Ń}EX̉Eꂽ
			} else if ((e.getModifiers() & InputEvent.BUTTON3_MASK) == InputEvent.BUTTON3_MASK) {
				int returnCode = ope.rightclick(e);

			}
		}
		State.setNodeHitID(-1);
	}

	//jPabel1Ń}EXNbNꂽ
	void jPanel1_mouseReleased(MouseEvent e) {
		if ((e.getModifiers() & InputEvent.BUTTON1_MASK) == InputEvent.BUTTON1_MASK) {
			ope.leftRelease(e);
		} else if ((e.getModifiers() & InputEvent.BUTTON3_MASK) == InputEvent.BUTTON3_MASK) {
			ope.rightRelease(e);
		}
		frameAdjust();
	}

	public static void Application1() {
		boolean packFrame = false;

		Frame1 frame = new Frame1();
		//validate() ̓TCY𒲐
		//pack() ͗LȃTCYCAEgȂǂ擾
		if (packFrame) {
			frame.pack();
		} else {
			frame.validate();
		}

		//EBhE𒆉ɔzu
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = frame.getSize();
		if (frameSize.height > screenSize.height) {
			frameSize.height = screenSize.height;
		}
		if (frameSize.width > screenSize.width) {
			frameSize.width = screenSize.width;
		}

		frame.addWindowListener(new WindowAdapter() {
			public void windowActivated(WindowEvent e) {
				jPanel1.repaint();
			}

		});

		frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
		frame.setVisible(true);
	}

	public void frameAdjust() {
		//`̈̎Zo
		jPanel1.setPreferredSize(TempNode.calDrawArea());
		jPanel1.revalidate();
		jPanel1.repaint();
		jScrollPane1.revalidate();
		//Info.timeShow();
	}

	public void changeDispString() {
		TempNode current = TempNode.getRoot();
		String dispStr = new String();
		DisplayString rw = new DisplayString();

		//\px̍Đݒ
		do {
			//\ʂɂAi[ύX
			if (State.getDispType() == 0) //m[hx\
				dispStr = rw.getDispNodeLabel(current);
			else //DXL\ 
				dispStr = rw.getDispDXLDescription(current);
			current.setDispStr(dispStr);

			if (current.getNodeLabel().compareTo("true") == 0)
				current.setCl("T:");
			else if (current.getNodeLabel().compareTo("false") == 0)
				current.setCl("F:");
			else
				current.setCl("");

			Graphics g = this.getGraphics();
			current.setNodeSize(new Point(State.getDefaultNodeWidth(), State.getDefaultNodeHeight()));
			current.calcNodeSize(g);

			if (current.getNext() != null)
				current = current.getNext();

		} while (current.getNext() != null);
	}

	private boolean doParseAndAttEval() {
		//\
		boolean flag = parser.exe_parse();

		if (flag == false) {
			return false;
		}

		//W]
		Coordinate coordinate = new Coordinate();
		coordinate.coordinateCalc(TreeNode.getRoot().getChildren1());
		Parser.parsetree_to_hichart(TreeNode.getRoot().getChildren1());
		TempEdge.updatePoint();
		frameAdjust();

		//zIGx
		Cyclomatic.calculation(TreeNode.getRoot());

		return true;
	}
}
