package hicharted;

import java.awt.*;
import hicharted.dataStructure.*;

/**
 * GfB^Ԃ̏ێ
 */
public class State {
	private static int nodeNum = 1; //͂ꂽm[h
	private static int edgeNum = 1; //͂ꂽGbW
	private static int nodeType = 0; //m[h
	private static int edgeType = 0; //GbW
	private static int before = -1; //pl̃NbNꂽm[hIDۑ
	private static int after = -1; //plŃ}EXꂽƂ̃m[hID
	private static int nodeHitID = -1; //ENbNꏊɃm[h邩ǂA炻̃m[hID擾
	private static int edgeHitID = -1; //ENbNꏊɃGbW邩ǂA炻̃m[hID擾
	private static boolean downFlag = false; //pl̃m[hNbNꂽǂ̏
	private static boolean moveFlag = false; //NbNꂽm[hړ邩ǂ
	/** 
	 * Z\ 0:m[hx 1:DXL
	 */
	private static int dispType = 0;

	private final static Point defaultNodeSize = new Point(60, 30);
	public static final int ADJUST_X = 20;
	public static final int ADJUST_Y = 15;
	public static final int ADJUST_ID_X = 20;
	public static final int ADJUST_ID_Y = 15;
	public static final int ADJUST_LABEL_X = 20;
	public static final int ADJUST_LABEL_Y = 25;
	public static final int MARGIN = 10;
	public static final int ROWGAP = 12;
	public static final int EDGE_X_GAP = 20;

	public static final int DEFINED_LEFT = 10; //`ςݏZ
	public static final int TITLE_LEFT = 10; //oZ
	public static final int GENERAL_LEFT = 10; //ėpZ
	public static final int TERMINAL_LEFT = 10; //[qZ
	public static final int IF_LEFT = 10; //I𕪊Z
	public static final int PARAIF_LEFT = 10; //񕪊Z
	public static final int REPEAT_LEFT = 5; //AZ
	public static final int PRETEST_LEFT = 10; //O^Z
	public static final int POSTTEST_LEFT = 10; //㔻^Z

	public static final int DEFINED_RIGHT = 10; //`ςݏZ
	public static final int TITLE_RIGHT = 10; //oZ
	public static final int GENERAL_RIGHT = 10; //ėpZ
	public static final int TERMINAL_RIGHT = 10; //[qZ
	public static final int IF_RIGHT = 10; //I𕪊Z
	public static final int PARAIF_RIGHT = 10; //񕪊Z
	public static final int REPEAT_RIGHT = 5; //AZ
	public static final int PRETEST_RIGHT = 10; //O^Z
	public static final int POSTTEST_RIGHT = 10; //㔻^Z

	public static final int dummySize = 15; //_~[m[hTCY

	public static Dimension panelSize = null;

	public static HichartNode currentNode = null;
	public static int FONT_SIZE = 9;

	public static void format() {
		nodeNum = 1;
		edgeNum = 1;
		nodeType = 0;
		edgeType = 0;
		before = -1;
		after = -1;
		nodeHitID = -1;
		downFlag = false;
		moveFlag = false;
	}

	public static int getNextNodeNum() {
		int retunNumber = State.nodeNum;
		setNodeNum(State.nodeNum + 1);
		return retunNumber;
	}

	public static int getNodeNumState() {
		return State.nodeNum;
	}

	public static void setNodeNum(int num) {
		nodeNum = num;
	}

	public static int getNodeNum() {
		return nodeNum;
	}

	public static void setEdgeNum(int num) {
		edgeNum = num;
	}

	public static int getEdgeNum() {
		return edgeNum;
	}

	public static void setNodeType(int num) {
		nodeType = num;
	}

	public static int getNodeType() {
		return nodeType;
	}

	public static void setEdgeType(int num) {
		edgeType = num;
	}

	public static int getEdgeType() {
		return edgeType;
	}

	public static void setBefore(int num) {
		before = num;
	}

	public static int getBefore() {
		return before;
	}

	public static void setAfter(int num) {
		after = num;
	}

	public static int getAfter() {
		return after;
	}

	public static void setNodeHitID(int num) {
		nodeHitID = num;
	}

	public static int getNodeHitID() {
		return nodeHitID;
	}

	public static void setEdgeHitID(int num) {
		edgeHitID = num;
	}

	public static int getEdgeHitID() {
		return edgeHitID;
	}

	public static void setDownFlag(boolean value) {
		downFlag = value;
	}

	public static boolean getDownFlag() {
		return downFlag;
	}

	public static void setMoveFlag(boolean value) {
		moveFlag = value;
	}

	public static boolean getMoveFlag() {
		return moveFlag;
	}

	public static int getDefaultNodeHeight() {
		return (int) State.defaultNodeSize.getY();
	}

	public static int getDefaultNodeWidth() {
		return (int) State.defaultNodeSize.getX();
	}

	public static void setDispType(int type) {
		dispType = type;
	}

	public static int getDispType() {
		return dispType;
	}
}
