package hicharted.dataStructure;

import java.awt.*;

/*  TreeNodeNX  */
public class TreeNode {
	private int x0 = -1; //HichartZxW
	private int x1 = -1; //HichartZxW
	private int x2 = -1; //HichartZxW
	private int x3 = -1; //HichartZxW
	private int y0 = -1; //HichartZyW
	private int y1 = -1; //HichartZyW
	private int y2 = -1; //HichartZyW
	private int y3 = -1; //HichartZyW
	private int top0 = -1; //HichartZtopW
	private int top1 = -1; //HichartZtopW
	private int top2 = -1; //HichartZtopW
	private int top3 = -1; //HichartZtopW
	private int bottom0 = -1; //HichartZbottomW
	private int bottom1 = -1; //HichartZbottomW
	private int bottom2 = -1; //HichartZbottomW
	private int bottom3 = -1; //HichartZbottomW
	public int cy0 = 0; //TCN}eBbNGx
	public int cy1 = 0; //TCN}eBbNGx
	public int cy2 = 0; //TCN}eBbNGx
	public int cy3 = 0; //TCN}eBbNGx
	private StringBuffer sSvg0 = new StringBuffer();
	private StringBuffer sSvg1 = new StringBuffer();
	private StringBuffer sSvg2 = new StringBuffer();
	private StringBuffer sSvg3 = new StringBuffer();
	private int t0 = 1; //SVGAj[Vԗp
	private int t1; //SVGAj[Vԗp
	private int t2; //SVGAj[Vԗp
	private int t3; //SVGAj[Vԗp
	private int GapX = 20; //TreeNodem̊Ԋu
	private int GapY = 30; //TreeNodem̊Ԋu
	private int w1 = 60; //HichartZ̕
	private int h1 = 20; //HichartZ̍
	private int production = 0; //Kpꂽv_NV
	private int nodeID = 0; //Ώۃm[hʔԍ

	private int rx = 10; //`pW
	private int ry = 20; //`pW
	private int ID = -1; //\͗pHichartXgioperationjō\͂sۂIDi[
	private int after_temp = -1; //\؍쐬TempƂĎgp
	private TreeNode parent = null; //e
	private TreeNode children1 = null; //q1
	private TreeNode children2 = null; //q2

	private static TreeNode root = new TreeNode();

	private HichartNode hlink = null; //HichartNodeւ̃N
	private Sequence slink = null; //Sequenceւ̃N
	private TempNode templink = null; //TempNodeւ̃N

	private TreeNode pthit;

	private int visit = 0;

	/**
	 * \؂ɈœnꂽafterZ邩ǂ
	 */
	public TreeNode searchTreeNode(TreeNode pt, HichartNode after) {
		pthit = null;
		if (pt.getAfter_temp() == after.getNodeID()) {
			pthit = pt;
			return pthit;
		}
		if (pthit == null && pt.getChildren1() != null)
			searchTreeNode(pt.getChildren1(), after);
		if (pthit == null && pt.getChildren2() != null)
			searchTreeNode(pt.getChildren2(), after);
		return pthit;
	}

	/**
	 * \؂ɈœnꂽafterZ邩ǂ
	 */
	public TreeNode searchTreeNode(TreeNode pt, int id) {
		pthit = null;
		if (pt.getAfter_temp() == id) {
			pthit = pt;
			return pthit;
		}
		if (pthit == null && pt.getChildren1() != null)
			searchTreeNode(pt.getChildren1(), id);
		if (pthit == null && pt.getChildren2() != null)
			searchTreeNode(pt.getChildren2(), id);
		return pthit;
	}

	/**
	 * ؍\m[hꗗ\
	 */
	public static void Print_Tree_Node(TreeNode tn) {
		System.out.println("\nproduction: " + tn.getProduction());
		if (tn.getHlink() != null) {
			System.out.println("tn.hlink.nodeID :" + tn.getHlink().getNodeID());
			System.out.println("tn.hlink.nodesize.x :" + tn.getHlink().getNodeSize().x);
		}
		if (tn.getTemplink() != null) {
			System.out.println("tn.templink.nodeID :" + tn.getTemplink().getNodeID());
			System.out.println("tn.templink.nodeID :" + tn.getTemplink().getNodeSize().x);
		}

		if (tn.getParent() != null) {
			System.out.println("tn.parent.production: " + tn.getParent().getProduction());
		}

		if (tn.getChildren1() != null)
			Print_Tree_Node(tn.getChildren1());

		if (tn.getChildren2() != null)
			Print_Tree_Node(tn.getChildren2());

	}

	public static Dimension calDrawArea() {
		Dimension size = new Dimension(0, 0);

		return size;
	}

	public void setX0(int x0) {
		this.x0 = x0;
	}

	public int getX0() {
		return x0;
	}

	public void setX1(int x1) {
		this.x1 = x1;
	}

	public int getX1() {
		return x1;
	}

	public void setX2(int x2) {
		this.x2 = x2;
	}

	public int getX2() {
		return x2;
	}

	public int setX3(int x3) {
		return this.x3 = x3;
	}

	public int getX3() {
		return x3;
	}

	public void setY0(int y0) {
		this.y0 = y0;
	}

	public int getY0() {
		return y0;
	}

	public void setY1(int y1) {
		this.y1 = y1;
	}

	public int getY1() {
		return y1;
	}

	public int setY2(int y2) {
		return this.y2 = y2;
	}

	public int getY2() {
		return y2;
	}

	public int setY3(int y3) {
		return this.y3 = y3;
	}

	public int getY3() {
		return y3;
	}

	public void setTop0(int top0) {
		this.top0 = top0;
	}

	public int getTop0() {
		return top0;
	}

	public void setTop1(int top1) {
		this.top1 = top1;
	}

	public int getTop1() {
		return top1;
	}

	public int setTop2(int top2) {
		return this.top2 = top2;
	}

	public int getTop2() {
		return top2;
	}

	public int setTop3(int top3) {
		return this.top3 = top3;
	}

	public int getTop3() {
		return top3;
	}

	public void setBottom0(int bottom0) {
		this.bottom0 = bottom0;
	}

	public int getBottom0() {
		return bottom0;
	}

	public int setBottom1(int bottom1) {
		return this.bottom1 = bottom1;
	}

	public int getBottom1() {
		return bottom1;
	}

	public int setBottom2(int bottom2) {
		return this.bottom2 = bottom2;
	}

	public int getBottom2() {
		return bottom2;
	}

	public int setBottom3(int bottom3) {
		return this.bottom3 = bottom3;
	}

	public int getBottom3() {
		return bottom3;
	}

	public void setCy0(int cy0) {
		this.cy0 = cy0;
	}

	public int getCy0() {
		return cy0;
	}

	public void setCy1(int cy1) {
		this.cy1 = cy1;
	}

	public int getCy1() {
		return cy1;
	}

	public void setCy2(int cy2) {
		this.cy2 = cy2;
	}

	public int getCy2() {
		return cy2;
	}

	public void setCy3(int cy3) {
		this.cy3 = cy3;
	}

	public int getCy3() {
		return cy3;
	}

	public void setT0(int t0) {
		this.t0 = t0;
	}

	public int getT0() {
		return t0;
	}

	public void setT1(int t1) {
		this.t1 = t1;
	}

	public int getT1() {
		return t1;
	}

	public void setT2(int t2) {
		this.t2 = t2;
	}

	public int getT2() {
		return t2;
	}

	public void setT3(int t3) {
		this.t3 = t3;
	}

	public int getT3() {
		return t3;
	}

	public void setGapX(int gapX) {
		GapX = gapX;
	}

	public int getGapX() {
		return GapX;
	}

	public void setGapY(int gapY) {
		GapY = gapY;
	}

	public int getGapY() {
		return GapY;
	}

	public void setW1(int w1) {
		this.w1 = w1;
	}

	public int getW1() {
		return w1;
	}

	public void setH1(int h1) {
		this.h1 = h1;
	}

	public int getH1() {
		return h1;
	}

	public void setProduction(int production) {
		this.production = production;
	}

	public int getProduction() {
		return production;
	}

	public void setNodeID(int nodeID) {
		this.nodeID = nodeID;
	}

	public int getNodeID() {
		return nodeID;
	}

	public void setRx(int rx) {
		this.rx = rx;
	}

	public int getRx() {
		return rx;
	}

	public void setRy(int ry) {
		this.ry = ry;
	}

	public int getRy() {
		return ry;
	}

	public void setID(int iD) {
		ID = iD;
	}

	public int getID() {
		return ID;
	}

	public void setAfter_temp(int after_temp) {
		this.after_temp = after_temp;
	}

	public int getAfter_temp() {
		return after_temp;
	}

	public void setParent(TreeNode parent) {
		this.parent = parent;
	}

	public TreeNode getParent() {
		return parent;
	}

	public void setChildren1() {
		this.children1 = new TreeNode();
		this.children1.setParent(this);
	}

	public void setChildren1(TreeNode children1) {
		this.children1 = children1;
		this.children1.setParent(this);
	}

	public TreeNode getChildren1() {
		return children1;
	}

	public void setChildren2(TreeNode children2) {
		this.children2 = children2;
	}

	public void setChildren2() {
		this.children2 = new TreeNode();
	}

	public TreeNode getChildren2() {
		return children2;
	}

	public void setHlink(HichartNode hlink) {
		this.hlink = hlink;
	}

	public HichartNode getHlink() {
		return hlink;
	}

	public void setSlink(Sequence slink) {
		this.slink = slink;
	}

	public Sequence getSlink() {
		return slink;
	}

	public void setTemplink(TempNode templink) {
		this.templink = templink;
	}

	public TempNode getTemplink() {
		return templink;
	}

	public static void setRoot() {
		TreeNode.root = new TreeNode();
	}

	public static TreeNode getRoot() {
		return root;
	}

	public StringBuffer getSSvg0() {
		return sSvg0;
	}

	public void setSSvg0(StringBuffer s) {
		//public void setSSvg0(String s) {
		sSvg0 = s;
	}

	public StringBuffer getSSvg1() {
		return sSvg1;
	}

	public void setSSvg1(StringBuffer s) {
		sSvg1 = s;
	}

	public StringBuffer getSSvg2() {
		return sSvg2;
	}

	public void setSSvg2(StringBuffer s) {
		sSvg2 = s;
	}

	public StringBuffer getSSvg3() {
		return sSvg3;
	}

	public void setSSvg3(StringBuffer s) {
		sSvg3 = s;
	}

	public void setVist(int n) {
		visit = n;
	}

	public int getVisit() {
		return visit;
	}
}