package hicharted.event;
import hicharted.dataStructure.*;

import java.awt.*;

/**
 * o؂̕`
 * 
 *
 */
public class DrawDerivationTree {
	static final int NODESIZE = 7;

	public static void draw(Graphics g, TreeNode n) {
		if (n.getProduction() != 0) {
			g.fillOval(n.getRx(), n.getRy(), NODESIZE, NODESIZE); //m[h`
			g.drawString("p" + Integer.toString(n.getProduction()), n.getRx(), n.getRy() - 5); //v_NVio[̕`
			if (n.getParent() != null && n.getParent().getProduction() != 0) {
				g.drawLine(n.getParent().getRx(), n.getParent().getRy() + 3, n.getRx(), n.getRy() + 3);
			}
			g.drawString(Integer.toString(n.cy0), n.getRx() - 5, n.getRy() + 15); //zIGx̕`
		}
		if (n.getChildren1() != null) {
			draw(g, n.getChildren1());
		}
		if (n.getChildren2() != null) {
			draw(g, n.getChildren2());
		}
	}

}
