package hicharted.event;
import hicharted.dataStructure.*;

import java.awt.*;
import java.util.*;
import hicharted.*;

/**
 * GbW`
 * @version 1.0
 */
public class DrawEdge {
	public static void draw(Graphics g) {
		int from_num = 0;
		int to_num = 0;
		TempNode tempnode = new TempNode();
		TempNode tempnode2 = new TempNode();
		TempEdge tempedge = TempEdge.getRoot();

		while (tempedge != null) {
			boolean findflag1 = false;
			boolean findflag2 = false;
			from_num = tempedge.getFrom_node();
			to_num = tempedge.getTo_node();

			tempnode = TempNode.getRoot();
			while (tempnode != null) {
				if (tempnode.getNodeID() == from_num) {
					findflag1 = true;
					break;
				}
				if (tempnode.getNext() != null) {
					tempnode = tempnode.getNext();
				} else
					tempnode = null;
			}

			tempnode2 = TempNode.getRoot();
			while (tempnode2 != null) {
				if (tempnode2.getNodeID() == to_num) {
					findflag2 = true;
					break;
				}
				if (tempnode2.getNext() != null)
					tempnode2 = tempnode2.getNext();
				else
					tempnode2 = null;
			}

			if (findflag1 == true && findflag2 == true) {
				if (State.getDispType() == 1 && (tempnode.getNodeLabel().compareTo("if_then") == 0 || tempnode.getNodeLabel().compareTo("if_then") == 0 || tempnode.getNodeLabel().compareTo("else_if_then") == 0 || tempnode.getNodeLabel().compareTo("statement_head") == 0 || tempnode.getNodeLabel().compareTo("true") == 0 || tempnode.getNodeLabel().compareTo("false") == 0 || tempnode.getNodeLabel().compareTo("inclusive_case") == 0 || tempnode.getNodeLabel().compareTo("exclusive_case") == 0 || tempnode.getNodeLabel().compareTo("choice_specification") == 0)) {
					if (tempnode.getNodeLabel().compareTo("if_then") == 0 || tempnode.getNodeLabel().compareTo("else_if_then") == 0 || tempnode.getNodeLabel().compareTo("inclusive_case") == 0 || tempnode.getNodeLabel().compareTo("exclusive_case") == 0) {
						Vector children = tempnode.getChildren();
						if (children != null && children.size() > 0) {
							TempNode dummy;
							for (int i = 0; i < children.size(); i++) {
								dummy = (TempNode) children.get(i);
								if (children.size() == 1)
									g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2, dummy.getDrawPoint().x, (dummy.getDrawPoint().y + tempnode.getNodeSize().y / 2));
								else {
									g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().x + State.EDGE_X_GAP / 2, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2, dummy.getDrawPoint().x - State.EDGE_X_GAP/2, (dummy.getDrawPoint().y + dummy.getNodeSize().y / 2));
									g.drawLine(dummy.getDrawPoint().x - State.EDGE_X_GAP/2, (dummy.getDrawPoint().y + dummy.getNodeSize().y / 2), dummy.getDrawPoint().x, (dummy.getDrawPoint().y + dummy.getNodeSize().y / 2));
								}
								
							}
							g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2, tempnode.getDrawPoint().x + tempnode.getNodeSize().x + State.EDGE_X_GAP / 2, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2);
						}
					} else if (tempnode.getNodeLabel().compareTo("statement_head") == 0) {
						if (tempnode2.getNodeLabel().compareTo("statement_head") == 0) {
							TempNode dummy1, dummy2;
							dummy1 = TempNode.searchTempNode(tempnode.getChildNum());
							dummy2 = TempNode.searchTempNode(tempnode2.getChildNum());
							g.setColor(Color.BLUE);
							g.drawLine(dummy1.getDrawPoint().x + State.EDGE_X_GAP, dummy1.getDrawPoint().y + dummy1.getNodeSize().y, (dummy2.getDrawPoint().x + State.EDGE_X_GAP), dummy2.getDrawPoint().y);
							g.setColor(Color.BLACK);

						}
					}
				} else {
					switch (tempedge.getEdge_type()) {
						case 1 :
							g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2, tempnode2.getDrawPoint().x, (tempnode2.getDrawPoint().y + tempnode.getNodeSize().y / 2));
							break;
						case 2 :
							g.setColor(Color.BLUE);
							g.drawLine(tempnode.getDrawPoint().x + State.EDGE_X_GAP, tempnode.getDrawPoint().y + tempnode.getNodeSize().y, (tempnode2.getDrawPoint().x + State.EDGE_X_GAP), tempnode2.getDrawPoint().y);
							g.setColor(Color.BLACK);
					}
				}

			}

			if (tempedge.getNext() != null)
				tempedge = tempedge.getNext();
			else
				tempedge = null;

		}

	}
}
