package hicharted.event;
import hicharted.dataStructure.*;
import hicharted.*;

import java.awt.*;

/**
 * m[h`
 * 
 *
 */
public class DrawNode {
	public static void draw(Graphics2D g) {

		TempNode tempnode = TempNode.getRoot();

		//	m[h̕`
		while (tempnode != null) {

			switch (tempnode.getNodeTypeNumber()) {
				case 1 : //`ςݏZ
					g.setColor(Color.white);
					g.fillRect(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getNodeSize().x, tempnode.getNodeSize().y);
					g.setColor(Color.black);
					g.drawRect(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getNodeSize().x, tempnode.getNodeSize().y);
					g.drawLine(tempnode.getDrawPoint().x + tempnode.getLeftMargin(), tempnode.getDrawPoint().y, tempnode.getDrawPoint().x + tempnode.getLeftMargin(), tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					break;

				case 2 : //oZ
					//hԂ
					Polygon fillArea = new Polygon();
					fillArea.addPoint(tempnode.getDrawPoint().x + tempnode.getLeftMargin(), tempnode.getDrawPoint().y);
					fillArea.addPoint(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2);
					fillArea.addPoint(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2);
					fillArea.addPoint(tempnode.getDrawPoint().x + tempnode.getLeftMargin(), tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					fillArea.addPoint(tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y);
					fillArea.addPoint(tempnode.getDrawPoint().x + tempnode.getNodeSize().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2);
					fillArea.addPoint(tempnode.getDrawPoint().x + tempnode.getNodeSize().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2);
					fillArea.addPoint(tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y + tempnode.getNodeSize().y);

					g.setColor(Color.WHITE);
					g.fillPolygon(fillArea);
					g.fillRect(tempnode.getDrawPoint().x + tempnode.getLeftMargin(), tempnode.getDrawPoint().y, tempnode.getNodeSize().x - tempnode.getRightMargin() * 2, tempnode.getNodeSize().y);
					g.setColor(Color.BLACK);

					g.drawLine(tempnode.getDrawPoint().x + tempnode.getLeftMargin(), tempnode.getDrawPoint().y, tempnode.getDrawPoint().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2);
					//
					g.drawLine(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2, tempnode.getDrawPoint().x + tempnode.getLeftMargin(), tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					//
					g.drawLine(/*MARGIN +*/
					tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y,
					/*MARGIN +*/
					tempnode.getDrawPoint().x + tempnode.getNodeSize().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2);
					//E
					g.drawLine(/*MARGIN +*/
					tempnode.getDrawPoint().x + tempnode.getNodeSize().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2,
					/*MARGIN +*/
					tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					//E
					break;

				case 3 : //ėpZ
					if (State.getDispType() == 1 && (tempnode.getNodeLabel().compareTo("statement_head") == 0 || tempnode.getNodeLabel().compareTo("true") == 0 || tempnode.getNodeLabel().compareTo("false") == 0)) {

					} else {
						g.setColor(Color.white);
						g.fillRect(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getNodeSize().x, tempnode.getNodeSize().y);
						g.setColor(Color.black);
						g.drawRect(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getNodeSize().x, tempnode.getNodeSize().y);
					}
					break;

				case 4 : //[qZ
					g.setColor(Color.WHITE);
					g.fillArc(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getNodeSize().y, tempnode.getNodeSize().y, 90, 180);
					g.fillRect(tempnode.getDrawPoint().x + tempnode.getNodeSize().y / 2, tempnode.getDrawPoint().y, tempnode.getNodeSize().x - tempnode.getNodeSize().y, tempnode.getNodeSize().y);
					g.fillArc(tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getNodeSize().y, tempnode.getDrawPoint().y, tempnode.getNodeSize().y, tempnode.getNodeSize().y, -90, 180);
					g.setColor(Color.BLACK);

					g.drawArc(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getNodeSize().y, tempnode.getNodeSize().y, 90, 180);
					g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().y / 2, tempnode.getDrawPoint().y, tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getNodeSize().y / 2, tempnode.getDrawPoint().y);
					g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().y / 2, tempnode.getDrawPoint().y + tempnode.getNodeSize().y, tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getNodeSize().y / 2, tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					g.drawArc(tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getNodeSize().y, tempnode.getDrawPoint().y, tempnode.getNodeSize().y, tempnode.getNodeSize().y, -90, 180);
					break;

				case 5 : //I𕪊Z
					g.drawLine(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y);
					g.drawLine(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getDrawPoint().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					g.drawLine(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y, tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y, tempnode.getDrawPoint().x + tempnode.getNodeSize().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2);
					g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2, tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					break;

				case 6 : //񕪊Z
					g.drawLine(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin() + 5, tempnode.getDrawPoint().y);
					g.drawLine(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getDrawPoint().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					g.drawLine(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y, tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin() + 5, tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin() + 5, tempnode.getDrawPoint().y, tempnode.getDrawPoint().x + tempnode.getNodeSize().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2);
					g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().x, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2, tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin() + 5, tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y, tempnode.getDrawPoint().x + tempnode.getNodeSize().x - 5, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2);
					g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().x - 5, tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 2, tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					break;

				case 7 : //AZ
					g.drawRect(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getNodeSize().x, tempnode.getNodeSize().y);
					g.drawLine(tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y, tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y + tempnode.getNodeSize().y);
					break;

				case 8 : //O^Z
					g.drawRect(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getNodeSize().x, tempnode.getNodeSize().y);
					g.drawRect(tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y + tempnode.getNodeSize().y / 3, State.MARGIN, tempnode.getNodeSize().y - tempnode.getNodeSize().y / 3);
					break;

				case 9 : //㔻^Z
					g.drawRect(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, tempnode.getNodeSize().x, tempnode.getNodeSize().y);
					g.drawRect(tempnode.getDrawPoint().x + tempnode.getNodeSize().x - tempnode.getRightMargin(), tempnode.getDrawPoint().y, tempnode.getRightMargin(), tempnode.getNodeSize().y * 3 / 4);
					break;

				case 10 :
					//_~[Z
					g.fillOval(tempnode.getDrawPoint().x, tempnode.getDrawPoint().y, State.dummySize, State.dummySize);
					break;
			}

			if (tempnode.getNodeID() != 0) {
				String tmpString = tempnode.getDispStr();
				String drawString = "";
				char ch;
				int tempWidth = tempnode.getDrawPoint().x + State.ADJUST_X;
				int tempHeight = tempnode.getDrawPoint().y + State.ADJUST_Y;

				if (tmpString != null) {

					for (int i = 0; i < tmpString.length(); i++) {
						ch = tmpString.charAt(i);
						if (ch == '\n') {
							g.drawString(drawString, tempWidth, tempHeight);
							tempHeight += State.ROWGAP;
							drawString = "";
						} else {
							drawString += ch;
							if (i == tmpString.length() - 1)
								g.drawString(drawString, tempWidth, tempHeight);
						}
					}
				}

			}

			if (tempnode.getCl() != null) {
				g.drawString(tempnode.getCl(), tempnode.getDrawPoint().x, tempnode.getDrawPoint().y - 5); //
			}

			if (tempnode.getNext() != null)
				tempnode = tempnode.getNext();
			else
				tempnode = null;
		}

	}
}
