
package hicharted.event;

import hicharted.dataStructure.*;
import hicharted.*;
import java.util.*;
import java.io.*;

/**
 * t@C
 * 
 *
 */
public class FileEvent {
	private static TempNode work;

	public static int fileOpen(String nodeFfilePath) {
		FileReader fr = null;

		try {
			fr = new FileReader(nodeFfilePath);
			BufferedReader bufferedreader = new BufferedReader(fr);

			String line;
			int i = 1;
			int j = 0;

			//wb_[ǂݍ
			if ((line = bufferedreader.readLine()) != null) {
				//System.out.println("Read Header Information!");
				StringTokenizer st = new StringTokenizer(line);
				j = 1;
				while (st.hasMoreTokens()) {
					String temp = (String) st.nextToken();
					//System.out.println(temp + " at " + j + " of " + "Header");
					j++;
				}
			} else
				return 9;

			//System.out.println("\nRead Cell Information!");
			//Zǂݍ
			while ((line = bufferedreader.readLine()) != null) {
				//System.out.println("Start line at " + i);
				j = 1;
				StringTokenizer st = new StringTokenizer(line);

				TempNode.insert();
				work = TempNode.getEnd().getBack();

				TempNode dummy = new TempNode();
				dummy = TempNode.getEnd().getBack();

				while (st.hasMoreTokens()) {
					String temp = (String) st.nextToken();
					if (temp.compareTo("%") == 0) {
						break;
					} else {

						switch (j) {
							case 1 :
								work.setNodeID(Integer.parseInt(temp));
								break;
							case 2 :
								work.setNodeTypeNumber(Integer.parseInt(temp));
								break;
							case 3 :
								if (temp.compareTo("null") != 0)
									work.setNodeLabel(temp);
								break;

							case 4 :
								String string1 = "";
								Stack stringStack = new Stack();

								if (temp.compareTo("null") != 0) {
									if (temp.startsWith("\""))
										stringStack.push("\"");

									while (!stringStack.empty()) {
										if (temp.startsWith("\""))
											string1 = string1 + temp;
										else
											string1 = string1 + " " + temp;

										if (temp.endsWith("\""))
											stringStack.pop();
										else {
											if (st.hasMoreElements())
												temp = (String) st.nextToken();
											else {
												if (!stringStack.empty()) {
													line = bufferedreader.readLine();
													st = new StringTokenizer(line);
													string1 = string1 + "\n";
													temp = (String) st.nextToken();
												}
											}
										}

									}
									work.setString1(string1.substring(1, string1.length() - 1));
								}
								break;
							case 5 :
								if (temp.compareTo("null") != 0)
									work.setString2(temp);
								break;

							case 6 :
								if (temp.compareTo("null") != 0)
									work.setLl(temp);
								break;
							case 7 :
								if (temp.compareTo("null") != 0)
									work.setCl(temp);
								break;
							case 8 :
								if (Integer.parseInt(temp) != -1)
									work.setParentNum(Integer.parseInt(temp));
								break;
							case 9 :
								if (Integer.parseInt(temp) != -1)
									work.setChild_num(Integer.parseInt(temp));
								break;
							case 10 :
								if (Integer.parseInt(temp) != -1)
									work.setOldBrotherNum(Integer.parseInt(temp));
								break;
							case 11 :
								if (Integer.parseInt(temp) != -1)
									work.setYoungerBrotherNum(Integer.parseInt(temp));
								break;
							case 12 :
								work.setDrawPointX(Integer.parseInt(temp));
								break;
							case 13 :
								work.setDrawPointY(Integer.parseInt(temp));
								break;
							case 14 :
								work.setNodeSizeX(Integer.parseInt(temp));
								break;
							case 15 :
								work.setNodeSizeY(Integer.parseInt(temp));
								break;

							default :
								break;
						}
						work.setLeftMargin();
						work.setRightMargin();
						//System.out.println(temp + " at " + j + " of " + i);
					}
					j++;
				}
				i++;
			}

		} catch (Exception e) {
			//System.out.println("t@CG[" + e);
			Message.showMessage("File open error");
			return 9;
		} finally {
			try {
				//Xg[
				fr.close();
			} catch (IOException e) {
				//System.out.println("N[YɗOB");
				e.printStackTrace();
			}
		}
		//TempNode.Print_Temp_Node();

		TempNode work = TempNode.getRoot().getNext();
		while (work.getNodeLabel().compareTo("end") != 0) {
			if (work.getChildNum() != -1) {
				State.setBefore(work.getNodeID());
				State.setAfter(work.getChildNum());
				State.setEdgeType(1);
				TempEdge.insert();
			}
			if (work.getYoungerBrotherNum() != -1) {
				State.setBefore(work.getNodeID());
				State.setAfter(work.getYoungerBrotherNum());
				State.setEdgeType(2);
				TempEdge.insert();
			}

			State.setBefore(-1);
			State.setAfter(-1);
			State.setEdgeType(0);

			work = work.getNext();
		}
		return 0;
	}

	public static void fileSave(String nodeFfilePath) {
		try {
			FileWriter fw = null;
			try {
				fw = new FileWriter(nodeFfilePath);

				fw.write(Integer.toString(TempNode.getRoot().getNext().getNodeID()));
				fw.write(" ");

				fw.write(Integer.toString(TempNode.getEnd().getBack().getNodeID()));
				fw.write(" ");

				fw.write(Integer.toString(State.getNodeNumState()));
				fw.write("\n");

				work = TempNode.getRoot().getNext();

				while (work.getNodeLabel().compareTo("end") != 0) {
					//@m[hID
					fw.write(Integer.toString(work.getNodeID()));
					fw.write(" ");

					//Am[hʔԍ
					fw.write(Integer.toString(work.getNodeTypeNumber()));
					fw.write(" ");

					//Bp[Ypm[hx
					if (work.getNodeLabel() != null && work.getNodeLabel().length() != 0) {
						fw.write(work.getNodeLabel());
						fw.write(" ");
					} else {
						fw.write("null");
						fw.write(" ");
					}

					//CZ͕1
					if (work.getString1() != null && work.getString1().length() != 0) {
						fw.write("\"");
						fw.write(work.getString1());
						fw.write("\"");
						fw.write(" ");
					} else {
						fw.write("null");
						fw.write(" ");
					}

					//DZ͕2
					if (work.getString2() != null && work.getString2().length() != 0) {
						fw.write("\"");
						fw.write(work.getString2());
						fw.write(" ");
						fw.write("\"");
					} else {
						fw.write("null");
						fw.write(" ");
					}

					//Eհޓ͗pZD
					if (work.getLl() != null && work.getLl().length() != 0) {
						fw.write(work.getLl());
						fw.write(" ");
					} else {
						fw.write("null");
						fw.write(" ");
					}

					//Fx
					if (work.getCl() != null && work.getCl().length() != 0) {
						fw.write(work.getCl());
						fw.write(" ");
					} else {
						fw.write("null");
						fw.write(" ");
					}

					//GeID
					fw.write(Integer.toString(work.getParentNum()));
					fw.write(" ");

					//HqID
					if (work.getChildNum() == -1) {
						fw.write("-1");
						fw.write(" ");
					} else {
						fw.write(Integer.toString(work.getChildNum()));
						fw.write(" ");
					}

					//IZID
					fw.write(Integer.toString(work.getOldBrotherNum()));
					fw.write(" ");

					//JID
					fw.write(Integer.toString(work.getYoungerBrotherNum()));
					fw.write(" ");

					//KZ`XW
					fw.write(Integer.toString(work.getDrawPoint().x));
					fw.write(" ");

					//LZ`YW
					fw.write(Integer.toString(work.getDrawPoint().y));
					fw.write(" ");

					//MZTCY
					fw.write(Integer.toString(work.getNodeSize().x));
					fw.write(" ");

					//NZTCY
					fw.write(Integer.toString(work.getNodeSize().y));

					fw.write("\n");

					if (work.getNext() == null)
						work = null;
					else
						work = work.getNext();
				}
			} catch (Exception e) {
				Message.showMessage("File save error");
			} finally {
				try {
					//Xg[
					fw.close();
					//Message.showMessage("t@Cɕۑ܂B");
				} catch (IOException e) {
					//System.out.println("N[YɗOB");
					e.printStackTrace();
				}
			}
		} catch (Exception e) {
			Message.showMessage("File save error");
		}
	}

}
