package hicharted.hcpgg;

import hicharted.dataStructure.*;
import hicharted.*;

import hicharted.attribute.*;
import java.util.*;

public class P14 extends Production {
	public P14() {
		this.setRuleNo(14);
		HichartNode lhs = new HichartNode();
		HichartNode rhs = new HichartNode();

		//left hand side
		lhs.setNodeLabel("Statement_list");
		lhs.setNodeID(0);
		this.setLhs(lhs);

		//right hand side
		rhs.setNodeLabel("empty_statement_list");
		rhs.setNodeID(1);
		this.setRhs(rhs);

		this.setLeftMargin(State.GENERAL_LEFT);
		this.setRightMargin(State.GENERAL_RIGHT);
	}

	public void coordinateAttCalcI(TreeNode n) {
		n.setX0(n.getParent().getX2());
		n.setX1(n.getX0());
		n.setTop0(n.getParent().getTop2());
		n.setTop1(n.getTop0());

	}

	public void coordinateAttCalcS(TreeNode n) {

		//n.setY1(n.getTop0());
		n.setY0(n.getY1());
		n.setBottom1(n.getY1() + n.getH1());
		n.setBottom0(n.getBottom1());

		n.getParent().setY2(n.getY0());
		n.getParent().setBottom2(n.getBottom0());

		//x2,y2,top2,bottom2,x3,y3,top3,bottom3m[h͂̐Kɂ݂͑Ȃ0ŏ
		n.setX2(n.setY2(n.setTop2(n.setBottom2(n.setX3(n.setY3(n.setTop3(n.setBottom3(0))))))));
	}

	public void genSvg(TreeNode n) {
		StringBuffer temp = new StringBuffer("<rect x=\"" + n.getX1() + "\" y=\"" + n.getY1() + "\" width=\"" + n.getW1() + "\" height=\"" + n.getH1() + "\" fill=\"white\" fill-opacity=\"1\" stroke=\"black\">\n");
		n.setSSvg1(temp);
		n.getSSvg1().append("</rect>\n");

		Vector strings = SVGout.getStrings(n.getTemplink().getDispStr());
		int gapY = 0;
		for (int i = 0; i < strings.size(); i++) {
			n.getSSvg1().append("<text x=\"" + (n.getX1() + State.ADJUST_ID_X) + "\" y=\"" + (n.getY1() + State.ADJUST_ID_Y + gapY) + "\" font-size=\"" + State.FONT_SIZE + "\">" + strings.get(i) + "</text>\n");
			gapY += State.ROWGAP;
		}
		n.getSSvg1().append("\n");

		n.setSSvg0(n.getSSvg1());
	}
	public void cyclomaticCalc(TreeNode n) {
		n.setCy0(0);
	}
}
