package hicharted.hcpgg;

import hicharted.dataStructure.*;

public class P18 extends Production {
	public P18() {
		this.setRuleNo(18);
		HichartNode lhs = new HichartNode();
		HichartNode rhs = new HichartNode();

		//left hand side
		lhs.setNodeLabel("Statement");
		lhs.setNodeID(0);
		this.setLhs(lhs);

		//right hand side
		rhs.setNodeLabel("Fundamental_statement");
		rhs.setNodeID(1);
		this.setRhs(rhs);
	}

	public void coordinateAttCalcI(TreeNode n) {
		n.setX1(n.getX0());
		n.setTop1(n.getTop0());

		n.getChildren1().setX0(n.getX1());
		n.getChildren1().setTop0(n.getTop1());
	}

	public void coordinateAttCalcS(TreeNode n) {
		n.setY0(n.getY1());
		n.setBottom0(n.getBottom1());

		if (n.getParent().getProduction() == 17) {
			n.getParent().setY1(n.getY0());
			n.getParent().setBottom1(n.getBottom0());

		} else {
			n.getParent().setY2(n.getY0());
			n.getParent().setBottom2(n.getBottom0());
		}
	}

	public void genSvg(TreeNode n) {
		n.setSSvg1(n.getChildren1().getSSvg0());
		n.setSSvg0(n.getSSvg1());
	}
	public void cyclomaticCalc(TreeNode n) {
		if (n.getChildren1() != null) {
			n.setCy1(n.getChildren1().getCy0());
		}
		n.setCy0(n.getCy1());
	}
}