package hicharted.hcpgg;

import hicharted.dataStructure.HichartNode;

public class PrecedenceRelation {
	private static int SIZE = 150; //ʊ֌W\̃TCY
	private static int precedenceRelation[][] = new int[SIZE][SIZE];

	/**
	 * Ώۃm[hI[I[𔻒肷
	 * @param hn ΏHichartNode
	 * @return 0:I[̏ꍇ@
	 *          1:I[̏ꍇ
	 */
	public static int judgeTerminal(HichartNode hn) {
		if (toNumber(hn) < 100) {
			return 0;
		} else
			return 1;
	}
	/**
	 * m[hxΉm[hǗԍ擾
	 * @param str m[hx
	 * @return int m[hǗԍ
	 */
	public static int toNumber(String str) {
		if (str.compareTo("m_packet") == 0)
			return (101);
		else if (str.compareTo("profile") == 0)
			return (102);
		else if (str.compareTo("identifier_is") == 0)
			return (103);
		else if (str.compareTo("explanation") == 0)
			return (104);
		else if (str.compareTo("module_algorithm") == 0)
			return (105);
		else if (str.compareTo("empty_statement_list") == 0)
			return (106); //K14̏I[
		else if (str.compareTo("statement_head") == 0)
			return (107);
		else if (str.compareTo("label") == 0)
			return (108);
		else if (str.compareTo("imperative") == 0)
			return (109);
		else if (str.compareTo("imperative_null") == 0)
			return (110);
		else if (str.compareTo("imperative_call") == 0)
			return (111);
		else if (str.compareTo("imperative_goto") == 0)
			return (112);
		else if (str.compareTo("block_identifier") == 0)
			return (113);
		else if (str.compareTo("abstract") == 0)
			return (114);
		else if (str.compareTo("block_specification") == 0)
			return (115);
		else if (str.compareTo("begin") == 0)
			return (116);
		else if (str.compareTo("parallel") == 0)
			return (117);
		else if (str.compareTo("pre_condition_for") == 0)
			return (118);
		else if (str.compareTo("pre_condition_until") == 0)
			return (119);
		else if (str.compareTo("pre_condition_while") == 0)
			return (120);
		else if (str.compareTo("pre_condition") == 0)
			return (121);
		else if (str.compareTo("post_condition_while") == 0)
			return (122);
		else if (str.compareTo("post_condition_until") == 0)
			return (123);
		else if (str.compareTo("post_condition") == 0)
			return (124);
		else if (str.compareTo("loop") == 0)
			return (125);
		else if (str.compareTo("monadic_if_then") == 0)
			return (126);
		else if (str.compareTo("branch_dummy") == 0)
			return (127);
		else if (str.compareTo("if_then") == 0)
			return (128);
		else if (str.compareTo("else_if_then") == 0)
			return (129);
		else if (str.compareTo("exclusive_case") == 0)
			return (130);
		else if (str.compareTo("inclusive_case") == 0)
			return (131);
		else if (str.compareTo("empty_when_statement") == 0)
			return (132);
		else if (str.compareTo("choice_specification") == 0)
			return (133);
		else if (str.compareTo("terminate_system") == 0)
			return (134);
		else if (str.compareTo("terminate_module") == 0)
			return (135);
		else if (str.compareTo("terminate_block") == 0)
			return (136);
		else if (str.compareTo("true") == 0)
			return (137);
		else if (str.compareTo("false") == 0)
			return (138);
		else
			return (-1);
	}
	/**
	 * m[hxm[hǗԍ擾
	 * @param hn Hichartf[^\
	 * @return int m[hǗԍ
	 */
	public static int toNumber(HichartNode hn) {
		//I[m[h
		if (hn.getNodeLabel().compareTo("Module_packet") == 0)
			return (1);
		else if (hn.getNodeLabel().compareTo("Profile_module_list") == 0)
			return (2);
		else if (hn.getNodeLabel().compareTo("Profile") == 0)
			return (3);
		else if (hn.getNodeLabel().compareTo("Module_list") == 0)
			return (4);
		else if (hn.getNodeLabel().compareTo("Explanation") == 0)
			return (5);
		else if (hn.getNodeLabel().compareTo("Module") == 0)
			return (6);
		else if (hn.getNodeLabel().compareTo("Explanation_module_algorithm") == 0)
			return (7);
		else if (hn.getNodeLabel().compareTo("Module_algorithm") == 0)
			return (8);
		else if (hn.getNodeLabel().compareTo("Statement_list") == 0)
			return (9);
		else if (hn.getNodeLabel().compareTo("Statement_head") == 0)
			return (10);
		else if (hn.getNodeLabel().compareTo("Label_statement") == 0)
			return (11);
		else if (hn.getNodeLabel().compareTo("Statement") == 0)
			return (12);
		else if (hn.getNodeLabel().compareTo("Fundamental_statement") == 0)
			return (13);
		else if (hn.getNodeLabel().compareTo("Blocked_statement") == 0)
			return (14);
		else if (hn.getNodeLabel().compareTo("Terminate_statement") == 0)
			return (15);
		else if (hn.getNodeLabel().compareTo("Abstract_compound") == 0)
			return (16);
		else if (hn.getNodeLabel().compareTo("Abstract") == 0)
			return (17);
		else if (hn.getNodeLabel().compareTo("Compound_statement") == 0)
			return (18);
		else if (hn.getNodeLabel().compareTo("Block_specification") == 0)
			return (19);
		else if (hn.getNodeLabel().compareTo("Sequential_statement") == 0)
			return (20);
		else if (hn.getNodeLabel().compareTo("Parallel_statement") == 0)
			return (21);
		else if (hn.getNodeLabel().compareTo("Iterative_statement") == 0)
			return (22);
		else if (hn.getNodeLabel().compareTo("Selective_statement") == 0)
			return (23);
		else if (hn.getNodeLabel().compareTo("Parallel_statement_list") == 0)
			return (24);
		else if (hn.getNodeLabel().compareTo("Pre_tested_statement") == 0)
			return (25);
		else if (hn.getNodeLabel().compareTo("Post_tested_statement") == 0)
			return (26);
		else if (hn.getNodeLabel().compareTo("Continued_statement") == 0)
			return (27);
		else if (hn.getNodeLabel().compareTo("If_then_statement") == 0)
			return (28);
		else if (hn.getNodeLabel().compareTo("Exclusive_select_statement") == 0)
			return (29);
		else if (hn.getNodeLabel().compareTo("Inclusive_select_statement") == 0)
			return (30);
		else if (hn.getNodeLabel().compareTo("Branch_statement_list_cushion") == 0)
			return (31);
		else if (hn.getNodeLabel().compareTo("Branch_statement_list") == 0)
			return (32);
		else if (hn.getNodeLabel().compareTo("Else_if_statement") == 0)
			return (33);
		else if (hn.getNodeLabel().compareTo("Exclusive_if_statement") == 0)
			return (34);
		else if (hn.getNodeLabel().compareTo("Exclusive_case_statement") == 0)
			return (35);
		else if (hn.getNodeLabel().compareTo("When_statement") == 0)
			return (36);
		else if (hn.getNodeLabel().compareTo("Choice_statement") == 0)
			return (37);
		else if (hn.getNodeLabel().compareTo("When_statement_cushion") == 0)
			return (38);
		else if (hn.getNodeLabel().compareTo("True_statement_list") == 0)
			return (39);
		else if (hn.getNodeLabel().compareTo("False_statement_list") == 0)
			return (40);

		//I[m[h
		else if (hn.getNodeLabel().compareTo("m_packet") == 0)
			return (101);
		else if (hn.getNodeLabel().compareTo("profile") == 0)
			return (102);
		else if (hn.getNodeLabel().compareTo("identifier_is") == 0)
			return (103);
		else if (hn.getNodeLabel().compareTo("explanation") == 0)
			return (104);
		else if (hn.getNodeLabel().compareTo("module_algorithm") == 0)
			return (105);
		else if (hn.getNodeLabel().compareTo("empty_statement_list") == 0)
			return (106); //K14̏I[
		else if (hn.getNodeLabel().compareTo("statement_head") == 0)
			return (107);
		else if (hn.getNodeLabel().compareTo("label") == 0)
			return (108);
		else if (hn.getNodeLabel().compareTo("imperative") == 0)
			return (109);
		else if (hn.getNodeLabel().compareTo("imperative_null") == 0)
			return (110);
		else if (hn.getNodeLabel().compareTo("imperative_call") == 0)
			return (111);
		else if (hn.getNodeLabel().compareTo("imperative_goto") == 0)
			return (112);
		else if (hn.getNodeLabel().compareTo("block_identifier") == 0)
			return (113);
		else if (hn.getNodeLabel().compareTo("abstract") == 0)
			return (114);
		else if (hn.getNodeLabel().compareTo("block_specification") == 0)
			return (115);
		else if (hn.getNodeLabel().compareTo("begin") == 0)
			return (116);
		else if (hn.getNodeLabel().compareTo("parallel") == 0)
			return (117);
		else if (hn.getNodeLabel().compareTo("pre_condition_for") == 0)
			return (118);
		else if (hn.getNodeLabel().compareTo("pre_condition_until") == 0)
			return (119);
		else if (hn.getNodeLabel().compareTo("pre_condition_while") == 0)
			return (120);
		else if (hn.getNodeLabel().compareTo("pre_condition") == 0)
			return (121);
		else if (hn.getNodeLabel().compareTo("post_condition_while") == 0)
			return (122);
		else if (hn.getNodeLabel().compareTo("post_condition_until") == 0)
			return (123);
		else if (hn.getNodeLabel().compareTo("post_condition") == 0)
			return (124);
		else if (hn.getNodeLabel().compareTo("loop") == 0)
			return (125);
		else if (hn.getNodeLabel().compareTo("monadic_if_then") == 0)
			return (126);
		else if (hn.getNodeLabel().compareTo("branch_dummy") == 0)
			return (127);
		else if (hn.getNodeLabel().compareTo("if_then") == 0)
			return (128);
		else if (hn.getNodeLabel().compareTo("else_if_then") == 0)
			return (129);
		else if (hn.getNodeLabel().compareTo("exclusive_case") == 0)
			return (130);
		else if (hn.getNodeLabel().compareTo("inclusive_case") == 0)
			return (131);
		else if (hn.getNodeLabel().compareTo("empty_when_statement") == 0)
			return (132);
		else if (hn.getNodeLabel().compareTo("choice_specification") == 0)
			return (133);
		else if (hn.getNodeLabel().compareTo("terminate_system") == 0)
			return (134);
		else if (hn.getNodeLabel().compareTo("terminate_module") == 0)
			return (135);
		else if (hn.getNodeLabel().compareTo("terminate_block") == 0)
			return (136);
		else if (hn.getNodeLabel().compareTo("true") == 0)
			return (137);
		else if (hn.getNodeLabel().compareTo("false") == 0)
			return (138);
		else
			return (-1);
	}

	//ʊ֌W\̒lZbg
	//**ʊ֌WLΉ****************************
	//* ʊ֌WlȂ̏ꍇF0				       *
	//* ʊ֌WꍇF1	 ( = )   		   *
	//* ̒_̂قʂꍇF2  ( < ) *
	//* ̒_̂قʂꍇF3	 ( > ) *
	//* ʔrłȂꍇF4			 ( * ) *
	//**********************************************
	/**
	 * ʊ֌W\̒lZbg
	 */
	public PrecedenceRelation() {
		int i, j;
		for (i = 0; i < SIZE; i++) {
			for (j = 0; j < SIZE; j++)
				precedenceRelation[i][j] = 0;
		}

		//Module_packet̏ʊ֌W
		//Profile_module_list̏ʊ֌W
		//Profilȅʊ֌W
		precedenceRelation[3][4] = 1; //Module_list
		precedenceRelation[3][6] = 2; //Module
		precedenceRelation[3][103] = 2; //identifier_is

		//Module_list̏ʊ֌W

		//Explanation̏ʊ֌W
		precedenceRelation[5][8] = 1; //Module_algorithm
		precedenceRelation[5][105] = 2; //module_algorithm

		//Modulȅʊ֌W
		precedenceRelation[6][4] = 1; //Module_list
		precedenceRelation[6][6] = 2; //Module
		precedenceRelation[6][103] = 2; //identifier_is

		//Explanation_module_algorithm̏ʊ֌W

		//Module_algorithm̏ʊ֌W

		//Statement_list̏ʊ֌W

		//Statement_head̏ʊ֌W
		precedenceRelation[10][9] = 1; //Statement_list
		precedenceRelation[10][10] = 2; //Statement_head
		precedenceRelation[10][106] = 2; //empty_statement_list
		precedenceRelation[10][107] = 2; //statement_head

		//Label_statement̏ʊ֌W
		//Statement̏ʊ֌W
		//Fundamental_statement̏ʊ֌W
		//Blocked_statement̏ʊ֌W
		//Terminate_statement̏ʊ֌W
		//Abstract_compound̏ʊ֌W
		//Abstract̏ʊ֌W
		precedenceRelation[17][18] = 1; //Compound_statement
		precedenceRelation[17][20] = 2; //Sequential_statement
		precedenceRelation[17][21] = 2; //Parallel_statement
		precedenceRelation[17][22] = 2; //Iterative_statement
		precedenceRelation[17][23] = 2; //Selective_statement
		//precedenceRelation[17][24] = 2; //Parallel_statement_list
		precedenceRelation[17][25] = 2; //Pre_tested_statement
		precedenceRelation[17][26] = 2; //Post_tested_statement
		precedenceRelation[17][27] = 2; //Continued_statement
		precedenceRelation[17][28] = 2; //If_then_statement
		precedenceRelation[17][29] = 2; //Exclusive_select_statement
		precedenceRelation[17][30] = 2; //Inclusive_select_statement
		precedenceRelation[17][34] = 2; //Exclusive_if_statement
		precedenceRelation[17][35] = 2; //Exclusive_case_statement
		precedenceRelation[17][116] = 2; //begin
		precedenceRelation[17][117] = 2; //parallel
		precedenceRelation[17][118] = 2; //pre_condition_for
		precedenceRelation[17][119] = 2; //pre_condition_until
		precedenceRelation[17][120] = 2; //pre_condition_while
		precedenceRelation[17][121] = 2; //pre_condition
		precedenceRelation[17][122] = 2; //post_condition_while
		precedenceRelation[17][123] = 2; //post_condition_until
		precedenceRelation[17][124] = 2; //post_condition
		precedenceRelation[17][125] = 2; //loop
		precedenceRelation[17][126] = 2; //monadic_if_then
		precedenceRelation[17][128] = 2; //if_then
		precedenceRelation[17][130] = 2; //exclusive_case
		precedenceRelation[17][131] = 2; //inclusive_case

		//Compound_statement̏ʊ֌W
		//Block_specification̏ʊ֌W
		//Sequential_statement̏ʊ֌W
		//Parallel_statement̏ʊ֌W
		//Iterative_statement̏ʊ֌W
		//Selective_statement̏ʊ֌W
		//Parallel_statement_list̏ʊ֌W
		//Pre_tested_statement̏ʊ֌W
		//Post_tested_statement̏ʊ֌W
		//Continued_statement̏ʊ֌W
		//If_then_statement̏ʊ֌W
		//Exclusive_select_statement̏ʊ֌W
		//Inclusive_select_statement̏ʊ֌W
		//Branch_statement_list_cushion̏ʊ֌W

		//Branch_statement_list̏ʊ֌W
		precedenceRelation[32][32] = 1; //Branch_statement_list
		//precedenceRelation[32][33] = 1; //Else_if_statement
		//precedenceRelation[32][127] = 2; //branch_dummy
		precedenceRelation[32][129] = 2; //else_if_then

		//Else_if_statement̏ʊ֌W
		//Exclusive_if_statement̏ʊ֌W
		//Exclusive_case_statement̏ʊ֌W

		//Choice_statement̏ʊ֌W
		precedenceRelation[37][36] = 1; //When_statement
		precedenceRelation[37][37] = 2; //Choice_statement
		precedenceRelation[37][132] = 2; //empty_when_statement
		precedenceRelation[37][133] = 2; //choice_specification
		//When_statement_cushion̏ʊ֌W

		//True_statement_list̏ʊ֌W
		precedenceRelation[39][40] = 1; //False_statement_list
		precedenceRelation[39][138] = 2; //false

		//False_statement_list̏ʊ֌W
		precedenceRelation[40][138] = 2; //false

		// **************************************************************** //
		// I[
		// **************************************************************** //

		//m_packet̏ʊ֌W
		precedenceRelation[101][2] = 1; //Profile_module_list
		precedenceRelation[101][3] = 2; //Profile
		precedenceRelation[101][102] = 2; //profile

		//profilȅʊ֌W
		precedenceRelation[102][4] = 3; //Module_list
		precedenceRelation[102][5] = 1; //Explanation
		precedenceRelation[102][6] = 4; //Module
		precedenceRelation[102][103] = 4; //identifier_is
		precedenceRelation[102][104] = 2; //explanation

		//identifier_is̏ʊ֌W
		precedenceRelation[103][4] = 3; //Module_list
		precedenceRelation[103][5] = 2; //Explanation
		precedenceRelation[103][6] = 4; //Module
		precedenceRelation[103][7] = 1; //Explanation_module_algorithm
		precedenceRelation[103][8] = 2; //Module_algorithm
		precedenceRelation[103][103] = 4; //identifier_is
		precedenceRelation[103][104] = 2; //explanation
		precedenceRelation[103][105] = 2; //module_algorithm		

		//explanation̏ʊ֌W
		precedenceRelation[104][8] = 3; //Module_algorithm
		precedenceRelation[104][105] = 4; //module_algorithm

		//module_algorithm̏ʊ֌W
		precedenceRelation[105][9] = 1; //Statement_list
		precedenceRelation[105][10] = 2; //Statement_head
		precedenceRelation[105][106] = 2; //empty_statement_list
		precedenceRelation[105][107] = 2; //statement_head

		//empty_statement_list̏ʊ֌W

		//statement_head̏ʊ֌W
		precedenceRelation[107][10] = 3; //Statement_list
		precedenceRelation[107][10] = 4; //Statement_head
		precedenceRelation[107][11] = 1; //Label_statement
		precedenceRelation[107][12] = 2; //Statement
		precedenceRelation[107][13] = 2; //Fundamental_statement
		precedenceRelation[107][14] = 2; //Blocked_statement
		precedenceRelation[107][15] = 2; //Terminate_statement
		precedenceRelation[107][16] = 2; //Abstract_compound
		precedenceRelation[107][17] = 2; //Abstract
		precedenceRelation[107][18] = 2; //Compound_statement
		precedenceRelation[107][20] = 2; //Sequential_statement
		precedenceRelation[107][21] = 2; //Parallel_statement
		precedenceRelation[107][22] = 2; //Iterative_statement
		precedenceRelation[107][23] = 2; //Selective_statement
		precedenceRelation[107][25] = 2; //Pre_tested_statement
		precedenceRelation[107][26] = 2; //Post_tested_statement
		precedenceRelation[107][27] = 2; //Continued_statement
		precedenceRelation[107][28] = 2; //If_then_statement
		precedenceRelation[107][29] = 2; //Exclusive_select_statement
		precedenceRelation[107][30] = 2; //Inclusive_select_statement
		precedenceRelation[107][34] = 2; //Exclusive_if_statement
		precedenceRelation[107][35] = 2; //Exclusive_case_statement
		precedenceRelation[107][106] = 4; //empty_statement_list
		precedenceRelation[107][107] = 4; //statement_head
		precedenceRelation[107][108] = 2; //label
		precedenceRelation[107][109] = 2; //imperative
		precedenceRelation[107][110] = 2; //imperative_null
		precedenceRelation[107][111] = 2; //imperative_call
		precedenceRelation[107][112] = 2; //imperative_goto
		precedenceRelation[107][113] = 2; //block_identifier
		precedenceRelation[107][114] = 2; //abstract
		precedenceRelation[107][116] = 2; //begin
		precedenceRelation[107][117] = 2; //parallel
		precedenceRelation[107][118] = 2; //pre_condition_for
		precedenceRelation[107][119] = 2; //pre_condition_until
		precedenceRelation[107][120] = 2; //pre_condition_while
		precedenceRelation[107][121] = 2; //pre_condition
		precedenceRelation[107][122] = 2; //post_condition_while
		precedenceRelation[107][123] = 2; //post_condition_until
		precedenceRelation[107][124] = 2; //post_condition
		precedenceRelation[107][125] = 2; //loop
		precedenceRelation[107][126] = 2; //monadic_if_then
		precedenceRelation[107][128] = 2; //if_then
		precedenceRelation[107][130] = 2; //exclusive_case
		precedenceRelation[107][131] = 2; //inclusive_case
		precedenceRelation[107][134] = 2; //terminate_system
		precedenceRelation[107][135] = 2; //terminate_module
		precedenceRelation[107][136] = 2; //terminate_block

		//label̏ʊ֌W
		precedenceRelation[108][12] = 1; //Statement
		precedenceRelation[108][13] = 2; //Fundamental_statement
		precedenceRelation[108][14] = 2; //Blocked_statement
		precedenceRelation[108][15] = 2; //Terminate_statement
		precedenceRelation[108][16] = 2; //Abstract_compound
		precedenceRelation[108][17] = 2; //Abstract
		precedenceRelation[108][18] = 2; //Compound_statement
		precedenceRelation[108][20] = 2; //Sequential_statement
		precedenceRelation[108][21] = 2; //Parallel_statement
		precedenceRelation[108][22] = 2; //Iterative_statement
		precedenceRelation[108][23] = 2; //Selective_statement
		precedenceRelation[108][25] = 2; //Pre_tested_statement
		precedenceRelation[108][26] = 2; //Post_tested_statement
		precedenceRelation[108][27] = 2; //Continued_statement
		precedenceRelation[108][28] = 2; //If_then_statement
		precedenceRelation[108][29] = 2; //Exclusive_select_statement
		precedenceRelation[108][30] = 2; //Inclusive_select_statement
		precedenceRelation[108][34] = 2; //Exclusive_if_statement
		precedenceRelation[108][35] = 2; //Exclusive_case_statement
		precedenceRelation[108][109] = 2; //imperative
		precedenceRelation[108][110] = 2; //imperative_null
		precedenceRelation[108][111] = 2; //imperative_call
		precedenceRelation[108][112] = 2; //imperative_goto
		precedenceRelation[108][113] = 2; //block_identifier
		precedenceRelation[108][114] = 2; //abstract
		precedenceRelation[108][116] = 2; //begin
		precedenceRelation[108][117] = 2; //parallel
		precedenceRelation[108][118] = 2; //pre_condition_for
		precedenceRelation[108][119] = 2; //pre_condition_until
		precedenceRelation[108][120] = 2; //pre_condition_while
		precedenceRelation[108][121] = 2; //pre_condition
		precedenceRelation[108][122] = 2; //post_condition_while
		precedenceRelation[108][123] = 2; //post_condition_until
		precedenceRelation[108][124] = 2; //post_condition
		precedenceRelation[108][125] = 2; //loop
		precedenceRelation[108][126] = 2; //monadic_if_then
		precedenceRelation[108][128] = 2; //if_then
		precedenceRelation[108][130] = 2; //exclusive_case
		precedenceRelation[108][131] = 2; //inclusive_case
		precedenceRelation[108][134] = 2; //terminate_system
		precedenceRelation[108][135] = 2; //terminate_module
		precedenceRelation[108][136] = 2; //terminate_block

		//imperativȅʊ֌W
		//imperative_null̏ʊ֌W
		//imperative_call̏ʊ֌W
		//impertive_gotȍʊ֌W
		//block_identifieȑʊ֌W
		precedenceRelation[113][16] = 1; //Abstract_compound
		precedenceRelation[113][17] = 2; //Abstract
		precedenceRelation[113][18] = 2; //Compound_statement
		precedenceRelation[113][20] = 2; //Sequential_statement
		precedenceRelation[113][21] = 2; //Parallel_statement
		precedenceRelation[113][22] = 2; //Iterative_statement
		precedenceRelation[113][23] = 2; //Selective_statement
		precedenceRelation[113][25] = 2; //Pre_tested_statement
		precedenceRelation[113][26] = 2; //Post_tested_statement
		precedenceRelation[113][27] = 2; //Continued_statement
		precedenceRelation[113][28] = 2; //If_then_statement
		precedenceRelation[113][29] = 2; //Exclusive_select_statement
		precedenceRelation[113][30] = 2; //Inclusive_select_statement
		precedenceRelation[113][34] = 2; //Exclusive_if_statement
		precedenceRelation[113][35] = 2; //Exclusive_case_statement
		precedenceRelation[113][114] = 2; //abstract
		precedenceRelation[113][116] = 2; //begin
		precedenceRelation[113][117] = 2; //parallel
		precedenceRelation[113][118] = 2; //pre_condition_for
		precedenceRelation[113][119] = 2; //pre_condition_until
		precedenceRelation[113][120] = 2; //pre_condition_while
		precedenceRelation[113][121] = 2; //pre_condition
		precedenceRelation[113][122] = 2; //post_condition_while
		precedenceRelation[113][123] = 2; //post_condition_until
		precedenceRelation[113][124] = 2; //post_condition
		precedenceRelation[113][125] = 2; //loop
		precedenceRelation[113][126] = 2; //monadic_if_then
		precedenceRelation[113][128] = 2; //if_then
		precedenceRelation[113][130] = 2; //exclusive_case
		precedenceRelation[113][131] = 2; //inclusive_case

		//abstract̏ʊ֌W
		precedenceRelation[114][9] = 3; //Statement_list
		precedenceRelation[114][18] = 4; //Compound_statement
		precedenceRelation[114][19] = 1; //Block_specification
		precedenceRelation[114][20] = 4; //Sequential_statement
		precedenceRelation[114][21] = 4; //Parallel_statement
		precedenceRelation[114][22] = 4; //Iterative_statement
		precedenceRelation[114][23] = 4; //Selective_statement
		precedenceRelation[114][25] = 4; //Pre_tested_statement
		precedenceRelation[114][26] = 4; //Post_tested_statement
		precedenceRelation[114][27] = 4; //Continued_statement
		precedenceRelation[114][28] = 4; //If_then_statement
		precedenceRelation[114][29] = 4; //Exclusive_select_statement
		precedenceRelation[114][30] = 4; //Inclusive_select_statement
		precedenceRelation[114][34] = 4; //Exclusive_if_statement
		precedenceRelation[114][35] = 4; //Exclusive_case_statement
		precedenceRelation[114][115] = 2; //block_specification
		precedenceRelation[114][116] = 4; //begin
		precedenceRelation[114][117] = 4; //parallel
		precedenceRelation[114][118] = 4; //pre_condition_for
		precedenceRelation[114][119] = 4; //pre_condition_until
		precedenceRelation[114][120] = 4; //pre_condition_while
		precedenceRelation[114][121] = 4; //pre_condition
		precedenceRelation[114][122] = 4; //post_condition_while
		precedenceRelation[114][123] = 4; //post_condition_until
		precedenceRelation[114][124] = 4; //post_condition
		precedenceRelation[114][125] = 4; //loop
		precedenceRelation[114][126] = 4; //monadic_if_then
		precedenceRelation[114][128] = 4; //if_then
		precedenceRelation[114][130] = 4; //exclusive_case
		precedenceRelation[114][131] = 4; //inclusive_case

		//block_specification̏ʊ֌W
		//begin̏ʊ֌W
		precedenceRelation[116][9] = 1; //Statement_list
		precedenceRelation[116][10] = 2; //Statement_head
		precedenceRelation[116][107] = 2; //statement_head

		//parallel̏ʊ֌W
		precedenceRelation[117][9] = 1; //Statement_list
		precedenceRelation[117][10] = 2; //Statement_head
		precedenceRelation[117][107] = 2; //statement_head

		//pre_condition_foȑʊ֌W
		precedenceRelation[118][9] = 1; //Statement_list
		precedenceRelation[118][10] = 2; //Statement_head
		precedenceRelation[118][107] = 2; //statement_head

		//pre_condition_until̏ʊ֌W
		precedenceRelation[119][9] = 1; //Statement_list
		precedenceRelation[119][10] = 2; //Statement_head
		precedenceRelation[119][107] = 2; //statement_head

		//pre_condition_whilȅʊ֌W
		precedenceRelation[120][9] = 1; //Statement_list
		precedenceRelation[120][10] = 2; //Statement_head
		precedenceRelation[120][107] = 2; //statement_head

		//pre_condition̏ʊ֌W
		precedenceRelation[121][9] = 1; //Statement_list
		precedenceRelation[121][10] = 2; //Statement_head
		precedenceRelation[121][107] = 2; //statement_head

		//post_condition_whilȅʊ֌W
		precedenceRelation[122][9] = 1; //Statement_list
		precedenceRelation[122][10] = 2; //Statement_head
		precedenceRelation[122][107] = 2; //statement_head

		//post_condition_until̏ʊ֌W
		precedenceRelation[123][9] = 1; //Statement_list
		precedenceRelation[123][10] = 2; //Statement_head
		precedenceRelation[123][107] = 2; //statement_head

		//post_condition̏ʊ֌W
		precedenceRelation[124][9] = 1; //Statement_list
		precedenceRelation[124][10] = 2; //Statement_head
		precedenceRelation[124][107] = 2; //statement_head

		//loop̏ʊ֌W
		precedenceRelation[125][9] = 1; //Statement_list
		precedenceRelation[125][10] = 2; //Statement_head
		precedenceRelation[125][107] = 2; //statement_head

		//monadic_if_then̏ʊ
		precedenceRelation[126][39] = 1; //True_statement_list
		precedenceRelation[126][137] = 2; //true

		//branch_dummy̏ʊ֌W
		//precedenceRelation[127][9] = 1; //Statement_list
		//precedenceRelation[127][10] = 2; //Statement_head
		//precedenceRelation[127][33] = 3; //Else_if_statement
		//precedenceRelation[127][107] = 2; //statement_head
		//precedenceRelation[127][127] = 4; //branch_dummy
		//precedenceRelation[127][129] = 4; //else_if_then

		//if_then̏ʊ֌W
		precedenceRelation[128][32] = 1; //Branch_statement_list
		precedenceRelation[128][39] = 2; //True_statement_list
		precedenceRelation[128][40] = 2; //False_statement_list
		precedenceRelation[128][137] = 2; //true

		//else_if_then̏ʊ֌W
		precedenceRelation[129][32] = 1; //Branch_statement_list
		precedenceRelation[129][39] = 2; //True_statement_list
		precedenceRelation[129][137] = 2; //true

		//exclusive_casȅʊ֌W
		precedenceRelation[130][36] = 2; //When_statement
		precedenceRelation[130][37] = 2; //Choice_statement
		precedenceRelation[130][38] = 1; //When_statement_cushion
		precedenceRelation[130][132] = 2; //empty_when_statement
		precedenceRelation[130][133] = 2; //choice_specification

		//inclusive_casȅʊ֌W
		precedenceRelation[131][36] = 2; //When_statement
		precedenceRelation[131][37] = 2; //Choice_statement
		precedenceRelation[131][38] = 1; //When_statement_cushion
		precedenceRelation[131][132] = 2; //empty_when_statement
		precedenceRelation[131][133] = 2; //choice_specification

		//empty_when_statement̏ʊ֌W
		precedenceRelation[132][36] = 3; //When_statement
		precedenceRelation[132][37] = 4; //Choice_statement
		precedenceRelation[132][132] = 4; //empty_when_statement
		precedenceRelation[132][133] = 4; //choice_specification

		//choice_specification̏ʊ֌W
		precedenceRelation[133][9] = 1; //Statement_list
		precedenceRelation[133][10] = 2; //Statement_head
		precedenceRelation[133][36] = 3; //When_statement
		precedenceRelation[133][37] = 3; //Choice_statement
		precedenceRelation[133][107] = 2; //statement_head
		//precedenceRelation[133][127] = 2; //branch_dummy
		precedenceRelation[133][132] = 4; //empty_when_statement
		precedenceRelation[133][133] = 4; //choice_specification

		//terminate_system̏ʊ֌W
		//terminate_modulȅʊ֌W
		//terminate_block̏ʊ֌W

		//truȅʊ֌W
		precedenceRelation[137][9] = 1; //Statement_list
		precedenceRelation[137][10] = 2; //Statement_head
		precedenceRelation[137][40] = 3; //False_statement_list
		precedenceRelation[137][107] = 2; //statement_head
		precedenceRelation[137][138] = 4; //false

		//falsȅʊ֌W
		precedenceRelation[138][9] = 2; //Statement_list
		precedenceRelation[138][10] = 2; //Statement_head
		precedenceRelation[138][33] = 1; //Else_if_statement
		precedenceRelation[138][107] = 2; //statement_head
		precedenceRelation[138][129] = 2; //else_if_then
	}
	/**
	 * 2̃m[hǗԍAm[hԂ̏ʊ֌W擾
	 * @param n1 m[h1
	 * @param n2 m[h2
	 * @return ʊ֌W 0: ʊ֌WlȂ̏ꍇ, 
	 *                   1: ʊ֌Wꍇ, 
	 *                   2: ̒_̂قʂꍇ, 
	 *                   3:̒_̂قʂꍇ, 
	 *                   4:ʔrłȂꍇ
	 */
	public static int getPrecedence(int n1, int n2) {
		int a;

		//`FbN
		if (n1 < 0 || n2 < 0)
			return -1;

		a = precedenceRelation[n1][n2];
		//System.out.println(" " + n1 + "@ " + n2 + " " + precedenceRelation[n1][n2]);
		return (a);
	}
}