package hicharted.parser;

import java.util.*;

import hicharted.dataStructure.*;
import hicharted.hcpgg.*;

/**
 * Vtgm[hi[Ă郊Xg̏ʂAʂ̓m[h擾
 */
public class Top {
	static PrecedenceRelation pr = new PrecedenceRelation();

	/**
	 * ʃnhԂ
	 * @param operation Hichartf[^\
	 * @param orderdList Xg
	 * @return equalNode ʂm[h
	 * 
	 */
	public static HichartNode getTop(HichartNode operation, Vector orderdList) {
		int j, k;
		j = k = orderdList.size();
		if (j == 0 && k == 0) {
			return null;
		}
		HichartNode temp1, temp2, orderListNode, addNode, hichartGraph, equalNode, hit;
		addNode = hichartGraph = equalNode = null;
		int result;
		boolean shuffle = false;

		//XgŁAXg瓙ʊ֌Wm[hXgOɌ
		//T
		for (int i = k - 1; i >= 1; i--) {
			temp2 = (HichartNode) orderdList.get(i);
			temp1 = (HichartNode) orderdList.get(i - 1);
			/*System.out.println(
				PrecedenceRelation.toNumber(temp1)
					+ " "
					+ PrecedenceRelation.toNumber(temp2)
					+ " : "
					+ PrecedenceRelation.getPrecedence(PrecedenceRelation.toNumber(temp1), PrecedenceRelation.toNumber(temp2)));*/
			if (PrecedenceRelation.getPrecedence(PrecedenceRelation.toNumber(temp1), PrecedenceRelation.toNumber(temp2)) == 1) {
				j--;
			} else {
				break;
			}
		}

		//handle̍쐬
		for (int i = j - 1; i < k; i++) {
			orderListNode = (HichartNode) orderdList.get(i);
			if (equalNode == null) {
				//handle = orderListNode.copyNode(handle);
				equalNode = orderListNode.copyNode();
			} else {
				//̓Ot̐擪Ni[
				hichartGraph = operation.getRoot();
				//̓Othandlẽm[hi[
				hichartGraph = hichartGraph.searchHichartNode(hichartGraph, equalNode.getNodeID());
				//̓Otłhandlem[hƐ`Xg̃Jgm[h̊֌W𓾂
				result = equalNode.searchHichartNodeLink(hichartGraph, orderListNode.getNodeID());
				if (result == -1) {
					return null;
				}
				//nhɉm[h̏擾
				addNode = new HichartNode();
				//addNode = orderListNode.copyNode(addNode);
				addNode = orderListNode.copyNode();

				//̓Ot̃Nɏ]AhandlẽN쐬
				switch (result) {
					case 1 :
						equalNode.setParent(addNode);
						break;

					case 2 :
						equalNode.setChild1(addNode);
						break;

					case 3 :
						equalNode.setOlderBrother(addNode);
						break;

					case 4 :
						equalNode.setYoungerBrother(addNode);
						break;
					case 5 :
						equalNode.setChild2(addNode);
						break;
				}
			}
		}
		return equalNode;
	}
}
